C
C
C
      SUBROUTINE   BMER
     I                 (CPARM,CSCALU,CSNAM,COUT,COUTI,COUTC,COUTU,
     1                  CSCALD,CSFARG,CSCUSE,CSCUSX,CSDOC,CIND)
C
C     + + + PURPOSE + + +
C     routine to read the sorted versions of the files created
C     by BNAM and BREF and write out the system documentation.
C
C     + + + DUMMY ARGUMENTS + + +
      CHARACTER*14 CPARM,CSCALU,CSNAM,COUT,COUTI,COUTC,COUTU,CSCALD,
     &             CSFARG,CSCUSE,CSCUSX,CSDOC,CIND
C
C     + + + ARGUMENT DEFINITIONS + + +
C     CPARM  - name of file containing page parameters
C     CSCALU - name of file containing names of calling routines
C     CSNAM  - name of file containing routine names
C     COUT   - name of file to which system doc will be written
C     COUTI  - name of file to which intrinsic doc will be written
C     COUTC  - name of file to which common block doc will be written
C     COUTU  - name of file to which unknown routine doc will be written
C     CSCALD - name of file containing names of called routines
C     CSFARG - name of file containing names of arguments
C     CSCUSE - name of file containing common block use info by routine
C     CSCUSX - name of file containing common block use info by block
C     CSDOC  - name of file containing routine documentation
C     CIND   - name of file containing index information
C
C     + + + PARAMETERS + + +
      INTEGER      MXROUT
      PARAMETER   (MXROUT=1000)
C
C     + + + COMMON BLOCK + + +
      INCLUDE 'cfunit.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      UNUM,NNUM,APOS,XNUM,CNUM,CTMP,CDON,MARTP,PGOPT,
     &             I,I1,I2,I3,I4,I5,I6,I7,I8,J,CALCNT,TCALCT,
     &             LCNT,LPAGE,OFTYP,CFTYP,DNUM,
     &             MARGL,MARGR,INDPAG(MXROUT),INDCNT,
     &             FPARM,FSCALU,FSNAM, IOSTA0,
     &             FSCALD,FSFARG,FSCUSE,FSCUSX,FSDOC,FIND,POS
      CHARACTER*1  UTYP,NTYP,CIMO,AIMO,XIMO,BLNK,NULL,INDTYP(MXROUT),
     &             TTYP,CHTMP(8),CDOT(1),DTYP
      CHARACTER*8  NSOUR,NGRP,ONSOUR,
     &             DSOUR,DGRP,DROUT,CALBUF(8),
     &             USOUR,UGRP,UROUT,OUSOUR,TGRP,
     &             ASOUR,AVAR,OAVAR,
     &             CSOUR,CCBLK,CVAR,     OCCBLK,
     &             XSOUR,XCBLK,XVAR,XGRP,OXVAR,
     &             TSOUR,CUSE(20),INDNAM(MXROUT)
      CHARACTER*12 ATYP
      CHARACTER*20 BUFMRG,BUFMRL,BUFMRR
      CHARACTER*58 ADEF
      CHARACTER*70 TBUF
      LOGICAL      NOSNAM,NOCALU,NOCALD,NOFARG,NOCUSE,NOCUSX,NOINFO,
     +             MATCHU,MATCHD,MATCHA,MATCHC,MATCHX,MATCHI,
     +             GETOUT, NXTRTN, PROCED, L1DONE, L2DONE
C
C     + + + INTRINSICS + + +
      INTRINSIC    MOD,CHAR
C
C     + + + FUNCTIONS + + +
      INTEGER      LENSTR
C
C     + + + EXTERNALS + + +
      EXTERNAL     NEWROU, CTPAGE, LENSTR, CHRCHR, OPTPRM
C
C     + + + DATA INITIALIZATION + + +
      DATA  I1,  I2,  I3,  I4,  I5,  I6,  I7,  I8
     &     / 1,   2,   3,   4,   5,   6,   7,   8/
C
C     + + + INPUT FORMATS + + +
 1010 FORMAT (1X,A8,4X,2(1X,A8),I3,2X,A1)
 1015 FORMAT (1X,A8,4X,2(1X,A8),14X,A1)
 1020 FORMAT (1X,A8,5X,A8,I3,2X,A1)
 1030 FORMAT (1X,A8,5X,I2,2X,A8,2X,A1,2X,A12,3X,A58)
 1040 FORMAT (1X,A8,4X,3(1X,A8),I3,2X,A1)
 1050 FORMAT (1X,A8,4X,A70)
 1060 FORMAT (16I5)
 1070 FORMAT (8A1)
C
C     + + + OUTPUT FORMATS + + +
 2000 FORMAT(/,A,'ARGUMENTS:'/
     &      A,1X,'               declaration',/,
     &      A,1X,'order   name   type  size   status  explanation',/,
     &      A,1X,'-----  ------  -----------  ------  --',11('-----'))
 2005 FORMAT (//,A,A8,80X,A8,//,
     &        A,'This COMMON BLOCK is used by:',//,
     &        A,' name   routine    group   number  status',/,
     &        A,'------  -------  --------  ------  ------')
 2008 FORMAT (A,1X,A8,A8,1X,A8,3X,I3,6X,A1)
 2010 FORMAT (A,1X,A8,7(2X,A8,2X))
 2011 FORMAT (A,1X,8X,7(2X,A8,2X))
 2020 FORMAT (/ ,A,'**** DUPLICATE NAME IN GROUP: ',A8,I3,2X,A1,2X,A8)
 2030 FORMAT (//,A,A8,80X,A8,//,
     &        A,'The location of this called routine is UNKNOWN.',/)
 2035 FORMAT (//,A,A8,80X,A8,//,
     &        A,'This called routine is a SYSTEM INTRINSIC.',/)
 2040 FORMAT (//,A,A8,80X,A8,//,
     &        A,'This ENTRY POINT is from group ',8A1,/,
     &        A,'It is routine number ',I2,'.',/)
 2050 FORMAT (A,'CALLED BY:',//,A,' unknown')
 2060 FORMAT (A,'CALLED BY:',//,
     &        A,1X,'group     routine'/
     &        A,1X,'--------  -------')
 2070 FORMAT (A,'CALLS:',//
     &        A,1X,'routine',/,
     &        A,1X,'-------')
 2075 FORMAT (A,1X,8(A8,4X))
 2080 FORMAT (A,1X,I3,4X,A8,1X,A12,3X,A1,4X,A58)
 2082 FORMAT (A,1X,36X,A58)
 2085 FORMAT (/,A,'ARGUMENTS:',//,A,' none',/)
C2090 FORMAT (/,A,'COMMON USAGE:',//,A,' none',/)
 2095 FORMAT (A,'CALLS:',//,A,' none',/)
 2100 FORMAT (/,A,'COMMON USAGE:',//,
     &          A,1X,'block    name   status'/,
     &          A,1X,'------  ------  ------')
 2105 FORMAT (A,1X,A8,A8,3X,A1)
 2110 FORMAT (//,A,A8,80X,A8,//,
     &        A,'This SUBROUTINE is number ',I1,' in file ',8A1,/)
 2111 FORMAT (//,A,A8,80X,A8,//,
     &        A,'This SUBROUTINE is number ',I2,' in file ',8A1,/)
 2120 FORMAT (//,A,A8,80X,A8,//,A,
     &        'This INTEGER FUNCTION is number ',I1,' in file ',8A1,/)
 2121 FORMAT (//,A,A8,80X,A8,//,A,
     &        'This INTEGER FUNCTION is number ',I2,' in file ',8A1,/)
 2122 FORMAT (//,A,A8,80X,A8,//,A,
     &        'This REAL FUNCTION is number ',I1,' in file ',8A1,/)
 2123 FORMAT (//,A,A8,80X,A8,//,A,
     &        'This REAL FUNCTION is number ',I2,' in file ',8A1,/)
 2124 FORMAT (//,A,A8,80X,A8,//,A,
     &        'This DOUBLE PRECISION FUNCTION is number ',I1,
     &        ' in file ',8A1,/)
 2125 FORMAT (//,A,A8,80X,A8,//,A,
     &        'This DOUBLE PRECISION FUNCTION is number ',I2,
     &        ' in file ',8A1,/)
 2126 FORMAT (//,A,A8,80X,A8,//,A,
     &        'This CHARACTER FUNCTION is number ',I2,' in file ',8A1,/)
 2127 FORMAT (//,A,A8,80X,A8,//,A,
     &        'This CHARACTER FUNCTION is number ',I2,' in file ',8A1,/)
 2130 FORMAT (A,A70)
 2140 FORMAT (A,'*** This routine needs a short description ***')
 2150 FORMAT (20A1)
 2200 FORMAT (1X,A1,1X,A8,I5)
 2400 FORMAT ( //, I5, ' = pgline',
     $          /, I5, ' = marglf',
     $          /, I5, ' = margrt',
     $          /, I5, ' = margtp',
     $          /, I5, ' = pgmain',
     $          /, I5, ' = pgintr',
     $          /, I5, ' = pgcomn',
     $          /, I5, ' = pgunkn',
     $          /, I5, ' = pgform' )
C
C     + + + END SPECIFICATIONS + + +
C
      CDOT(1)= '.'
      FPARM  = 18
      FSCALU = 10
      FSNAM  = 11
      FOUTM  = 12
      FOUTI  = 31
      FOUTC  = 32
      FOUTU  = 33
      FSCALD = 13
      FSFARG = 14
      FSCUSE = 15
      FSCUSX = 16
      FSDOC  = 17
      FIND   = 19
C
      LCNT = 0
C
C     get formatting options
      CALL OPTPRM ( LPAGE, MARGL, MARGR, MARTP,
     O              PCNTM, PCNTI, PCNTC, PCNTU, PGOPT )
      WRITE (*,2400) LPAGE, MARGL, MARGR, MARTP,
     $               PCNTM, PCNTI, PCNTC, PCNTU, PGOPT
      IF (PGOPT .EQ. 0) LPAGE = 1000
C     adjust lines/page for page numbers
C     IF (LPAGE .NE. -1) LPAGE= LPAGE- 3
      LPAGE= LPAGE- 3
C     do the left and right page margin buffers
      BLNK = ' '
      NULL = CHAR(0)
      WRITE (BUFMRL,2150) (BLNK,I=1,MARGL),(NULL,I=MARGL+1,20)
      WRITE (BUFMRR,2150) (BLNK,I=1,MARGR),(NULL,I=MARGR+1,20)
C     init first page margin
      IF (MOD(PCNTM,2).EQ.0) THEN
C       convention is to use MRR on even page numbers
        BUFMRG= BUFMRR
      ELSE
C       and MRL on odd page numbers
        BUFMRG= BUFMRL
      END IF
C
C     open files containing doc info from programs bnam and bref
      OPEN (UNIT=FSCALU,FILE=CSCALU,STATUS='OLD')
      OPEN (UNIT=FSNAM, FILE=CSNAM, STATUS='OLD')
      OPEN (UNIT=FOUTM, FILE=COUT)
      OPEN (UNIT=FOUTI, FILE=COUTI)
      OPEN (UNIT=FOUTC, FILE=COUTC)
      OPEN (UNIT=FOUTU, FILE=COUTU)
      OPEN (UNIT=FSCALD,FILE=CSCALD,STATUS='OLD')
      OPEN (UNIT=FSFARG,FILE=CSFARG,STATUS='OLD')
      OPEN (UNIT=FSCUSE,FILE=CSCUSE,STATUS='OLD')
      OPEN (UNIT=FSCUSX,FILE=CSCUSX,STATUS='OLD')
      OPEN (UNIT=FSDOC, FILE=CSDOC, STATUS='OLD')
C
C     get initial records from each file
      NSOUR  = 'AAAAAAAA'
      NOSNAM = .TRUE.
      NOCALU = .TRUE.
      NOCALD = .TRUE.
      NOFARG = .TRUE.
      NOCUSE = .TRUE.
      CSOUR  = 'ZZZZZZZZ'
      NOCUSX = .TRUE.
      XSOUR  = 'ZZZZZZZZ'
C
C     read name of routines which call routine being processed
      READ (FSCALU,1010,IOSTAT=IOSTA0) USOUR,UROUT,UGRP,UNUM,UTYP
      IF (IOSTA0 .EQ. 0) NOCALU = .FALSE.
C
C     read name of routines called by routine being processed
      READ (FSCALD,1010,IOSTAT=IOSTA0) DROUT,DSOUR,DGRP,DNUM,DTYP
      IF (IOSTA0 .EQ. 0) NOCALD = .FALSE.
C
C     read argument names for routine in process
      READ (FSFARG,1030,IOSTAT=IOSTA0) ASOUR,APOS,AVAR,AIMO,ATYP,ADEF
      IF (IOSTA0 .EQ. 0) NOFARG = .FALSE.
C
C     read common information for routine in process
      READ (FSCUSE,1015,IOSTAT=IOSTA0) CSOUR,CCBLK,CVAR,CIMO
      IF (IOSTA0 .EQ. 0) NOCUSE = .FALSE.
C
C     read common information
      READ (FSCUSX,1040,IOSTAT=IOSTA0) XSOUR,XCBLK,XVAR,XGRP,XNUM,XIMO
      IF (IOSTA0 .EQ. 0) NOCUSX = .FALSE.
C
C     read documentation
      READ (FSDOC,1050,IOSTAT=IOSTA0) TSOUR,TBUF
      IF (IOSTA0 .EQ. 0) THEN
        NOINFO= .FALSE.
        OXVAR = '        '
        OAVAR = OXVAR
        INDCNT= 0
        CFTYP = 0
      END IF
C
C     loop to process each routine
      MATCHU = .FALSE.
      MATCHD = .FALSE.
      MATCHA = .FALSE.
      MATCHC = .FALSE.
      MATCHX = .FALSE.
      MATCHI = .FALSE.
      PROCED = .TRUE.
      GETOUT = .FALSE.
      L1DONE = .FALSE.
      L2DONE = .FALSE.
 100  CONTINUE
        IF (.NOT.L1DONE) THEN
C         loop to read name of routines to be processed
 150      CONTINUE
            IF (PROCED) THEN
              ONSOUR= NSOUR
              READ (FSNAM,1020,IOSTAT=IOSTA0) NSOUR,NGRP,NNUM,NTYP
              IF (IOSTA0 .EQ. 0) THEN
                NOSNAM = .FALSE.
                IF (ONSOUR.EQ.NSOUR) THEN
C                 duplicate name
                  CALL CTPAGE (CFTYP,BUFMRL,BUFMRR,LPAGE,I2,NSOUR,MARTP,
     I                         PGOPT,MARGL,MARGR,
     M                         BUFMRG,LCNT)
                  WRITE (FOUTM,2020) BUFMRG(1:MARGL),NGRP,NNUM,
     +                               NTYP,NSOUR
                  NXTRTN = .TRUE.
                ELSE
C                 new routine - reset flags
                  NXTRTN = .FALSE.
                  IF (USOUR .EQ. NSOUR) MATCHU = .TRUE.
                  IF (DSOUR .EQ. NSOUR) MATCHD = .TRUE.
                  IF (ASOUR .EQ. NSOUR) MATCHA = .TRUE.
                  IF (CSOUR .EQ. NSOUR) MATCHC = .TRUE.
                  IF (XSOUR .EQ. NSOUR) MATCHX = .TRUE.
                  IF (TSOUR .EQ. NSOUR) MATCHI = .TRUE.
                END IF
              ELSE
C               end-of-file - no more names to process
                NOSNAM = .TRUE.
                NSOUR= 'ZZZZZZZZ'
                L1DONE = .TRUE.
                IF (L2DONE) GETOUT = .TRUE.
              END IF
            ELSE
              PROCED = .TRUE.
              NXTRTN = .FALSE.
            END IF
          IF (NXTRTN) GO TO 150
        END IF
C
        IF (.NOT.GETOUT) THEN
          IF (.NOT.NOCALU .AND. USOUR.LT.NSOUR) THEN
C           calling routine not known
            PROCED = .FALSE.
            IF (UTYP.EQ.'C') THEN
C             its a COMMON block
              OFTYP= CFTYP
              CFTYP= 3
              CALL NEWROU (OFTYP,CFTYP,BUFMRL,BUFMRR,LPAGE,I8,
     I                     USOUR,UTYP,MARTP,PGOPT,MARGL,MARGR,
     M                     BUFMRG,LCNT,
     M                     MXROUT,INDCNT,INDPAG,INDNAM,INDTYP)
              WRITE (FOUTC,2005) BUFMRG(1:MARGL),USOUR,USOUR,
     +            BUFMRG(1:MARGL),BUFMRG(1:MARGL),BUFMRG(1:MARGL)
 200          CONTINUE
C               loop to write each variable in the common block
                IF (XCBLK.EQ.USOUR) THEN
C                 still in current common block, do next variable
                  IF (OXVAR.NE.XVAR) THEN
C                   skip a line between common variables
                    CALL CTPAGE (CFTYP,BUFMRL,BUFMRR,LPAGE,I1,USOUR,
     I                           MARTP,PGOPT,MARGL,MARGR,
     M                           BUFMRG,LCNT)
                    WRITE (FOUTC,2008)
                  END IF
C                 write next variable
                  CALL CTPAGE (CFTYP,BUFMRL,BUFMRR,LPAGE,I1,USOUR,MARTP,
     I                         PGOPT,MARGL,MARGR,
     M                         BUFMRG,LCNT)
                  WRITE (FOUTC,2008) BUFMRG(1:MARGL),XVAR,XSOUR,
     +                XGRP,XNUM,XIMO
                END IF
                IF (.NOT.NOCUSX) THEN
C                 read next common
                  OXVAR= XVAR
                  READ (FSCUSX,1040,IOSTAT=IOSTA0) XSOUR,XCBLK,XVAR,
     &                                             XGRP,XNUM,XIMO
                  IF (IOSTA0 .EQ. 0) THEN
                    IF (XSOUR .EQ. NSOUR ) THEN
                      MATCHX = .TRUE.
                    ELSE
                      MATCHX = .FALSE.
                    END IF
                  ELSE
                    MATCHX = .FALSE.
                    NOCUSX = .TRUE.
                  END IF
                END IF
              IF (.NOT.NOCUSX .AND. XCBLK .LE. USOUR) GO TO 200
C
 250          CONTINUE
C               loop to read each routine called
                IF (.NOT.NOCALU .AND. .NOT.GETOUT) THEN
                  OUSOUR= USOUR
                  READ (FSCALU,1010,IOSTAT=IOSTA0)
     +                USOUR,UROUT,UGRP,UNUM,UTYP
                  IF (IOSTA0 .EQ. 0 .AND. USOUR .NE. 'ZZZZZZZZ') THEN
                    IF (USOUR .EQ. NSOUR) THEN
                      MATCHU = .TRUE.
                    ELSE
                      MATCHU = .FALSE.
                    END IF
                  ELSE
                    NOCALU = .TRUE.
                    MATCHU = .FALSE.
                    L2DONE = .TRUE.
                    IF (L1DONE) GETOUT = .TRUE.
                  END IF
                END IF
              IF (.NOT.NOCALU .AND. USOUR.EQ.OUSOUR) GOTO 250
C
            ELSE
              IF (UTYP.EQ.'I') THEN
C               a system INTRINSIC
                OFTYP= CFTYP
                CFTYP= 2
                CALL NEWROU(OFTYP,CFTYP,BUFMRL,BUFMRR,LPAGE,I6,
     I                      USOUR,UTYP,MARTP,PGOPT,MARGL,MARGR,
     M                      BUFMRG,LCNT,
     M                      MXROUT,INDCNT,INDPAG,INDNAM,INDTYP)
                WRITE (FOUTI,2035) BUFMRG(1:MARGL), USOUR, USOUR,
     +                    BUFMRG(1:MARGL)
              ELSE
C               its an unknown SUBROUTINE
                TTYP= 'U'
                OFTYP= CFTYP
                CFTYP= 4
                CALL NEWROU(OFTYP,CFTYP,BUFMRL,BUFMRR,LPAGE,I6,
     I                      USOUR,TTYP,MARTP,PGOPT,MARGL,MARGR,
     M                      BUFMRG,LCNT,
     M                      MXROUT,INDCNT,INDPAG,INDNAM,INDTYP)
                WRITE (FOUTU,2030) BUFMRG(1:MARGL), USOUR, USOUR,
     +              BUFMRG(1:MARGL)
              END IF
C
C             routines which call heading
              CALL CTPAGE (CFTYP,BUFMRL,BUFMRR,LPAGE,I4,NSOUR,MARTP,
     I                     PGOPT,MARGL,MARGR,
     M                     BUFMRG,LCNT)
              WRITE (FOUT(CFTYP),2060) BUFMRG(1:MARGL),
     +                   BUFMRG(1:MARGL),BUFMRG(1:MARGL)
C             loop to write routines which call
              CALCNT= 0
              TCALCT= 0
              TGRP  = UGRP
 300          CONTINUE
                CALCNT= CALCNT+ 1
                TCALCT= TCALCT+ 1
                CALBUF(CALCNT)= UROUT
                IF (CALCNT.EQ.7) THEN
C                 write some routines which call
                  CALL CTPAGE (CFTYP,BUFMRL,BUFMRR,LPAGE,I1,NSOUR,MARTP,
     I                         PGOPT,MARGL,MARGR,
     M                         BUFMRG,LCNT)
                  IF (TCALCT.EQ.7) THEN
C                   write with code group name
                    WRITE (FOUT(CFTYP),2010) BUFMRG(1:MARGL),TGRP,
     +                  (CALBUF(I),I=1,7)
                  ELSE
C                   write without code group name
                    WRITE (FOUT(CFTYP),2011) BUFMRG(1:MARGL),
     +                  (CALBUF(I),I=1,7)
                  END IF
                  CALCNT= 0
                END IF
                IF (.NOT.NOCALU) THEN
                  OUSOUR= USOUR
                  READ (FSCALU,1010,IOSTAT=IOSTA0) USOUR,UROUT,
     +                                             UGRP,UNUM,UTYP
                  IF (IOSTA0 .EQ. 0 .AND. USOUR .NE. 'ZZZZZZZZ') THEN
                    IF (USOUR .EQ. NSOUR) THEN
                      MATCHU = .TRUE.
                    ELSE
                      MATCHU = .FALSE.
                    END IF
                  ELSE
                    NOCALU = .TRUE.
                    MATCHU = .FALSE.
                    L2DONE = .TRUE.
                    IF (L1DONE) GETOUT = .TRUE.
                  END IF
                END IF
                IF (NOCALU .OR. UGRP.NE.TGRP .OR. OUSOUR.NE.USOUR) THEN
C                 new source code group
                  IF (CALCNT.GT.0) THEN
C                   clear routines which call buffer
                    CALL CTPAGE (CFTYP,BUFMRL,BUFMRR,LPAGE,I1,NSOUR,
     I                           MARTP,PGOPT,MARGL,MARGR,
     M                           BUFMRG,LCNT)
                    IF (TCALCT.LE.7) THEN
C                     write with code group name
                      WRITE (FOUT(CFTYP),2010)
     &                  BUFMRG(1:MARGL),TGRP,(CALBUF(I),I=1,CALCNT)
                    ELSE
C                     write without code group name
                      WRITE (FOUT(CFTYP),2011)
     &                  BUFMRG(1:MARGL),(CALBUF(I),I=1,CALCNT)
                    END IF
                    CALCNT= 0
                    TCALCT= 0
                  END IF
                  TGRP= UGRP
                END IF
              IF (.NOT.GETOUT .AND. USOUR.EQ.OUSOUR .AND. .NOT.NOCALU)
     +            GO TO 300
            END IF
C
          ELSE
C           process the current routine
C           read CHAR*1 variable from NGRP for output with
C           a period at end
            READ (NGRP,1070) (CHTMP(J),J=1,8)
            POS= LENSTR(I8,CHTMP)+ 1
            IF (POS.LE.8) CALL CHRCHR(I1,CDOT(1),CHTMP(POS))
C
            IF (NTYP.EQ.'E') THEN
C             routine is the entry point
              OFTYP= CFTYP
              CFTYP= 1
              CALL NEWROU (OFTYP,CFTYP,BUFMRL,BUFMRR,LPAGE,I7,
     I                     NSOUR,NTYP,MARTP,PGOPT,MARGL,MARGR,
     M                     BUFMRG,LCNT,
     M                     MXROUT,INDCNT,INDPAG,INDNAM,INDTYP)
              WRITE (FOUTM,2040) BUFMRG(1:MARGL),NSOUR,NSOUR,
     +            BUFMRG(1:MARGL),CHTMP,BUFMRG(1:MARGL),NNUM
C
            ELSE IF (NTYP.EQ.'S') THEN
C             routine is a subroutine
              OFTYP= CFTYP
              CFTYP= 1
              CALL NEWROU (OFTYP,CFTYP,BUFMRL,BUFMRR,LPAGE,I6,
     I                     NSOUR,NTYP,MARTP,PGOPT,MARGL,MARGR,
     M                     BUFMRG,LCNT,
     M                     MXROUT,INDCNT,INDPAG,INDNAM,INDTYP)
              IF (NNUM .LT. 10) THEN
                WRITE (FOUTM,2110) BUFMRG(1:MARGL),NSOUR,NSOUR,
     +              BUFMRG(1:MARGL),NNUM,CHTMP
              ELSE
                WRITE (FOUTM,2111) BUFMRG(1:MARGL),NSOUR,NSOUR,
     +              BUFMRG(1:MARGL),NNUM,CHTMP
              END IF
C
            ELSE
C             routine is a function
              OFTYP= CFTYP
              CFTYP= 1
              CALL NEWROU (OFTYP,CFTYP,BUFMRL,BUFMRR,LPAGE,I6,
     I                     NSOUR,NTYP,MARTP,PGOPT,MARGL,MARGR,
     M                     BUFMRG,LCNT,
     M                     MXROUT,INDCNT,INDPAG,INDNAM,INDTYP)
              IF (NNUM.LT.10.AND.NTYP.EQ.'I') THEN
                WRITE (FOUTM,2120) BUFMRG(1:MARGL),NSOUR,NSOUR,
     +              BUFMRG(1:MARGL),NNUM,CHTMP
              ELSE IF (NTYP.EQ.'I') THEN
                WRITE (FOUTM,2121) BUFMRG(1:MARGL),NSOUR,NSOUR,
     +              BUFMRG(1:MARGL),NNUM,CHTMP
              ELSE IF (NNUM.LT.10.AND.NTYP.EQ.'R') THEN
                WRITE (FOUTM,2122) BUFMRG(1:MARGL),NSOUR,NSOUR,
     +              BUFMRG(1:MARGL),NNUM,CHTMP
              ELSE IF (NTYP.EQ.'R') THEN
                WRITE (FOUTM,2123) BUFMRG(1:MARGL),NSOUR,NSOUR,
     +              BUFMRG(1:MARGL),NNUM,CHTMP
              ELSE IF (NNUM.LT.10.AND.NTYP.EQ.'D') THEN
                WRITE (FOUTM,2124) BUFMRG(1:MARGL),NSOUR,NSOUR,
     +              BUFMRG(1:MARGL),NNUM,CHTMP
              ELSE IF (NTYP.EQ.'D') THEN
                WRITE (FOUTM,2125) BUFMRG(1:MARGL),NSOUR,NSOUR,
     +              BUFMRG(1:MARGL),NNUM,CHTMP
              ELSE IF (NNUM.LT.10.AND.NTYP.EQ.'C') THEN
                WRITE (FOUTM,2126) BUFMRG(1:MARGL),NSOUR,NSOUR,
     +              BUFMRG(1:MARGL),NNUM,CHTMP
              ELSE
                WRITE (FOUTM,2127) BUFMRG(1:MARGL),NSOUR,NSOUR,
     +              BUFMRG(1:MARGL),NNUM,CHTMP
              END IF
            END IF
C
C           general documentation from heading
            IF (MATCHI) THEN
C             its available
 400          CONTINUE
                CALL CTPAGE (CFTYP,BUFMRL,BUFMRR,LPAGE,I1,NSOUR,MARTP,
     I                       PGOPT,MARGL,MARGR,
     M                       BUFMRG,LCNT)
                WRITE (FOUTM,2130) BUFMRG(1:MARGL),TBUF
                IF (.NOT.NOINFO) THEN
                  READ  (FSDOC,1050,IOSTAT=IOSTA0) TSOUR,TBUF
                  IF (IOSTA0 .EQ. 0) THEN
                    IF (TSOUR .EQ. NSOUR) THEN
                      MATCHI = .TRUE.
                    ELSE
                      MATCHI = .FALSE.
                    END IF
                  ELSE
                    NOINFO = .TRUE.
                    MATCHI = .FALSE.
                  END IF
                END IF
              IF (.NOT.NOINFO .AND. MATCHI) GOTO 400
            ELSE
C             no doc available
              CALL CTPAGE (CFTYP,BUFMRL,BUFMRR,LPAGE,I1,NSOUR,MARTP,
     I                     PGOPT,MARGL,MARGR,
     M                     BUFMRG,LCNT)
              WRITE (FOUTM,2140) BUFMRG(1:MARGL)
            END IF
C
C           arguments
            IF (MATCHA) THEN
              CALL CTPAGE (CFTYP,BUFMRL,BUFMRR,LPAGE,I5,NSOUR,MARTP,
     I                     PGOPT,MARGL,MARGR,
     M                     BUFMRG,LCNT)
              WRITE (FOUTM,2000) BUFMRG(1:MARGL),BUFMRG(1:MARGL),
     +            BUFMRG(1:MARGL),BUFMRG(1:MARGL)
C             have arguments
 450          CONTINUE
                IF (AVAR.NE.OAVAR) THEN
                  CALL CTPAGE (CFTYP,BUFMRL,BUFMRR,LPAGE,I1,NSOUR,MARTP,
     I                         PGOPT,MARGL,MARGR,
     M                         BUFMRG,LCNT)
                  WRITE (FOUTM,2080) BUFMRG(1:MARGL),APOS,AVAR,
     +                ATYP,AIMO,ADEF
                ELSE
                  CALL CTPAGE (CFTYP,BUFMRL,BUFMRR,LPAGE,I1,NSOUR,MARTP,
     I                         PGOPT,MARGL,MARGR,
     M                         BUFMRG,LCNT)
                  WRITE (FOUTM,2082) BUFMRG(1:MARGL),ADEF
                END IF
                OAVAR= AVAR
                IF (.NOT.NOFARG) THEN
                  READ (FSFARG,1030,IOSTAT=IOSTA0) ASOUR,APOS,AVAR,
     +                                             AIMO,ATYP,ADEF
                  IF (IOSTA0 .EQ. 0) THEN
                    IF (ASOUR .EQ. NSOUR) THEN
                      MATCHA = .TRUE.
                    ELSE
                      MATCHA = .FALSE.
C                     reset old variable name to undefined
                      OAVAR= '        '
                    END IF
                  ELSE
                    NOFARG = .TRUE.
                    MATCHA = .FALSE.
                  END IF
                END IF
              IF (.NOT.NOFARG .AND. MATCHA) GO TO 450
            ELSE IF (NTYP.NE.'E') THEN
C             entry point, no arguments
              CALL CTPAGE (CFTYP,BUFMRL,BUFMRR,LPAGE,I5,NSOUR,MARTP,
     I                     PGOPT,MARGL,MARGR,
     M                     BUFMRG,LCNT)
              WRITE (FOUTM,2085) BUFMRG(1:MARGL),BUFMRG(1:MARGL)
            END IF
C
C           use of COMMON
            CNUM= 0
            IF (MATCHC) THEN
C             output heading
              CALL CTPAGE (CFTYP,BUFMRL,BUFMRR,LPAGE,I5,NSOUR,MARTP,
     I                     PGOPT,MARGL,MARGR,
     M                     BUFMRG,LCNT)
              WRITE (FOUTM,2100) BUFMRG(1:MARGL),BUFMRG(1:MARGL),
     +            BUFMRG(1:MARGL)
 500          CONTINUE
C               fill in array of what COMMON actually used
                CDON= 0
                CTMP= 0
 550            CONTINUE
                  CTMP= CTMP+ 1
                  IF (CTMP.GT.CNUM) THEN
                    CNUM= CNUM+ 1
                    CUSE(CNUM)= CCBLK
                    CDON= 1
                  ELSE
                    IF (CCBLK.EQ.CUSE(CTMP)) CDON= 1
                  END IF
                IF (CDON.EQ.0) GO TO 550
                CALL CTPAGE (CFTYP,BUFMRL,BUFMRR,LPAGE,I1,NSOUR,MARTP,
     I                       PGOPT,MARGL,MARGR,
     M                       BUFMRG,LCNT)
                WRITE (FOUTM,2105) BUFMRG(1:MARGL),CCBLK,CVAR,CIMO
                OCCBLK= CCBLK
                IF (.NOT.NOCUSE) THEN
                  READ (FSCUSE,1015,IOSTAT=IOSTA0) CSOUR,CCBLK,CVAR,CIMO
                    IF (IOSTA0 .EQ. 0) THEN
                      IF (CSOUR .EQ. NSOUR) THEN
                        MATCHC = .TRUE.
                      ELSE
                        MATCHC = .FALSE.
                      END IF
                    ELSE
                      MATCHC = .FALSE.
                      NOCUSE = .TRUE.
                    END IF
                  IF (.NOT.NOCUSE .AND. OCCBLK .NE. CCBLK
     +                .AND. MATCHC) THEN
C                   blank record between blocks
                    CALL CTPAGE (CFTYP,BUFMRL,BUFMRR,LPAGE,I1,NSOUR,
     I                           MARTP,PGOPT,MARGL,MARGR,
     M                           BUFMRG,LCNT)
                    WRITE (FOUTM,2105)
                  END IF
                END IF
              IF (.NOT.NOCUSE .AND. MATCHC) GO TO 500
C
C             blank record after all common
              CALL CTPAGE (CFTYP,BUFMRL,BUFMRR,LPAGE,I1,NSOUR,MARTP,
     I                     PGOPT,MARGL,MARGR,
     M                     BUFMRG,LCNT)
              WRITE (FOUTM,2105)
            ELSE
C             no common used
              CALL CTPAGE (CFTYP,BUFMRL,BUFMRR,LPAGE,I1,NSOUR,MARTP,
     I                     PGOPT,MARGL,MARGR,
     M                     BUFMRG,LCNT)
C
C             the following line has been commented out
C             if no COMMON used, do not write any messages
C             if this line is un-commented in the future, parameter
C             five in the above call to CTPAGE must be changed from
C             I1 to I5 and the WRITE statement following this WRITE
C             statement must be commented out.
CBS           WRITE (FOUTM,2090) BUFMRG(1:MARGL),BUFMRG(1:MARGL)
              WRITE (FOUTM,'(1H )')
C
            END IF
C
C           output routines called
            IF (MATCHD) THEN
C             called routines heading
              CALL CTPAGE (CFTYP,BUFMRL,BUFMRR,LPAGE,I4,NSOUR,MARTP,
     I                     PGOPT,MARGL,MARGR,
     M                     BUFMRG,LCNT)
              WRITE (FOUTM,2070) BUFMRG(1:MARGL),BUFMRG(1:MARGL),
     +            BUFMRG(1:MARGL)
C             output called routines
              CALCNT= 0
 600          CONTINUE
C               check to see if this is a used COMMON
                CDON= 0
                IF (CNUM.GT.0) THEN
                  DO 625 CTMP = 1,CNUM
                    IF (DROUT.EQ.CUSE(CTMP)) CDON= 1
                    IF (DTYP.EQ.'C') CDON= 1
 625              CONTINUE
                END IF
                IF (CDON.EQ.0) THEN
C                 a valid call
                  CALCNT= CALCNT+ 1
                  CALBUF(CALCNT)= DROUT
                  IF (CALCNT.EQ.8) THEN
C                   write a line of calls
                    CALL CTPAGE (CFTYP,BUFMRL,BUFMRR,LPAGE,I1,NSOUR,
     I                           MARTP,PGOPT,MARGL,MARGR,
     M                           BUFMRG,LCNT)
                    WRITE (FOUTM,2075) BUFMRG(1:MARGL),CALBUF
                    CALCNT= 0
                  END IF
                END IF
                IF (.NOT.NOCALD) THEN
                  READ (FSCALD,1010,IOSTAT=IOSTA0) DROUT,DSOUR,
     +                                             DGRP,DNUM,DTYP

                  IF (IOSTA0 .EQ. 0) THEN
                    NOCALD = .FALSE.
                    IF (DSOUR .EQ. NSOUR) THEN
                      MATCHD = .TRUE.
                    ELSE
                      MATCHD = .FALSE.
                    END IF
                  ELSE
                    NOCALD = .TRUE.
                    MATCHD = .FALSE.
                  END IF
                END IF
              IF (.NOT.NOCALD .AND. MATCHD) GO TO 600
              IF (CALCNT.GT.0) THEN
C               write a partial line of calls
                CALL CTPAGE (CFTYP,BUFMRL,BUFMRR,LPAGE,I1,NSOUR,MARTP,
     I                       PGOPT,MARGL,MARGR,
     M                       BUFMRG,LCNT)
                WRITE (FOUTM,2075) BUFMRG(1:MARGL),
     +                             (CALBUF(I),I=1,CALCNT)
              END IF
C             blank line
              CALL CTPAGE (CFTYP,BUFMRL,BUFMRR,LPAGE,I1,NSOUR,MARTP,
     I                     PGOPT,MARGL,MARGR,
     M                     BUFMRG,LCNT)
              WRITE (FOUTM,2075)
            ELSE
C             no calls from this routine
              CALL CTPAGE (CFTYP,BUFMRL,BUFMRR,LPAGE,I4,NSOUR,MARTP,
     I                     PGOPT,MARGL,MARGR,
     M                     BUFMRG,LCNT)
              WRITE (FOUTM,2095) BUFMRG(1:MARGL),BUFMRG(1:MARGL)
            END IF
C
C           routines which call
            IF (.NOT.NOCALU .AND. MATCHU) THEN
C             heading
              CALL CTPAGE (CFTYP,BUFMRL,BUFMRR,LPAGE,I4,NSOUR,MARTP,
     I                     PGOPT,MARGL,MARGR,
     M                     BUFMRG,LCNT)
              WRITE (FOUTM,2060) BUFMRG(1:MARGL),BUFMRG(1:MARGL),
     +            BUFMRG(1:MARGL)
C             loop to write routines which call
              CALCNT= 0
              TCALCT= 0
              TGRP  = UGRP
 650          CONTINUE
                CALCNT= CALCNT+ 1
                TCALCT= TCALCT+ 1
                CALBUF(CALCNT)= UROUT
                IF (CALCNT.EQ.7) THEN
C                 write some routines which call
                  CALL CTPAGE (CFTYP,BUFMRL,BUFMRR,LPAGE,I1,NSOUR,MARTP,
     I                         PGOPT,MARGL,MARGR,
     M                         BUFMRG,LCNT)
                  IF (TCALCT.EQ.7) THEN
C                   write with code group name
                    WRITE (FOUTM,2010) BUFMRG(1:MARGL),TGRP,
     +                  (CALBUF(I),I=1,7)
                  ELSE
C                   write without code group name
                    WRITE (FOUTM,2011) BUFMRG(1:MARGL),(CALBUF(I),I=1,7)
                  END IF
                  CALCNT= 0
                END IF
C
                IF (.NOT.NOCALU) THEN
                  OUSOUR = USOUR
                  READ (FSCALU,1010,IOSTAT=IOSTA0) USOUR,UROUT,UGRP,
     +                                             UNUM,UTYP
                  IF (IOSTA0 .EQ. 0 .AND. USOUR .NE. 'ZZZZZZZZ') THEN
                    IF (USOUR .EQ. NSOUR) THEN
                      MATCHU = .TRUE.
                    ELSE
                      MATCHU = .FALSE.
                    END IF
                  ELSE
                    NOCALU = .TRUE.
                    MATCHU = .FALSE.
                    L2DONE = .TRUE.
                    IF (L1DONE) GETOUT = .TRUE.
                  END IF
C
                  IF (NOCALU .OR. UGRP.NE.TGRP .OR. .NOT.MATCHU) THEN
C                   new source code group
                    IF (CALCNT.GT.0) THEN
C                     clear routines which call buffer
                      CALL CTPAGE (CFTYP,BUFMRL,BUFMRR,LPAGE,I1,NSOUR,
     I                             MARTP,PGOPT,MARGL,MARGR,
     M                             BUFMRG,LCNT)
                      IF (TCALCT.LE.7) THEN
C                       write with code group name
                        WRITE(FOUTM,2010) BUFMRG(1:MARGL),TGRP,
     +                      (CALBUF(I),I=1,CALCNT)
                      ELSE
C                       write without code group name
                        WRITE(FOUTM,2011) BUFMRG(1:MARGL),
     +                      (CALBUF(I),I=1,CALCNT)
                      END IF
                      CALCNT= 0
                      TCALCT= 0
                    END IF
                    TGRP= UGRP
                  END IF
                END IF
              IF (MATCHU) GO TO 650
            ELSE
C             no routines call
              CALL CTPAGE (CFTYP,BUFMRL,BUFMRR,LPAGE,I3,NSOUR,MARTP,
     I                     PGOPT,MARGL,MARGR,
     M                     BUFMRG,LCNT)
              WRITE (FOUTM,2050) BUFMRG(1:MARGL),BUFMRG(1:MARGL)
            END IF
          END IF
        END IF
C
      IF (.NOT.GETOUT) GO TO 100
C
C     write out last page number
      CALL CTPAGE (CFTYP,BUFMRL,BUFMRR,LPAGE,LPAGE,NSOUR,MARTP,
     I             PGOPT,MARGL,MARGR,
     M             BUFMRG,LCNT)
C
      CLOSE (UNIT=FSCALU)
      CLOSE (UNIT=FSNAM)
      CLOSE (UNIT=FOUTM)
      CLOSE (UNIT=FSCALD)
      CLOSE (UNIT=FSFARG)
      CLOSE (UNIT=FSCUSE)
      CLOSE (UNIT=FSCUSX)
      CLOSE (UNIT=FSDOC)
C
C     write out info for index
      OPEN (UNIT=FIND,FILE=CIND)
      DO 700 I= 1,INDCNT
        WRITE (FIND,2200) INDTYP(I),INDNAM(I),INDPAG(I)
 700  CONTINUE
      CLOSE (UNIT=FIND)
C
      RETURN
      END
