C
C
C
      SUBROUTINE   BREF
     I                 (CINP,CCALL,CNAM,CARG,CCUSE,CDOC,CADEF,DINTLN,
     I                  INTFIL,
     O                  ERRCOD)
C
C     + + + PURPOSE + + +
C     Routine to read FORTRAN cross reference listings which follow
C     the OSW coding conventions and write out information to be
C     sorted in the auto doc program.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER       DINTLN, ERRCOD
      CHARACTER*14  CINP,CCALL,CNAM,CARG,CCUSE,CDOC,CADEF
      CHARACTER*(*) INTFIL
C
C     + + + ARGUMENT DEFINTIONS + + +
C     CINP   - name of file containing names of FORTRAN listing files
C     CCALL  - name of file containing names, etc.  of routines called
C              from a given routine
C     CNAM   - name of file containing names of routines processed
C     CARG   - name of file containing arguments of routines processed
C     CCUSE  - name of file containing common block usage of routines
C              processed
C     CDOC   - name of file containing documentation (comments) of
C              routines processed
C     CADEF  - name of file containing definition of arguments of
C              routines processed
C     DINTLN - default integer length ( 2 (short) or 4 (long))
C     INTFIL - pathname of file containing list of valid INTRINSICS
C     ERRCOD - error return code
C               0 - Operation was successful
C              -1 - Operation failed
C
C     + + + PARAMETERS + + +
      INTEGER   MXNAME, MXDEFN, MXPURP
      PARAMETER ( MXNAME = 300, MXPURP = 100 )
      PARAMETER ( MXDEFN = MXNAME*5 )
C
C     + + + COMMON BLOCKS + + +
CBS   INCLUDE 'cdebug.inc'
CBS   INCLUDE 'ddebug.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      I2,I3,I6,I8,I10,I12,I28,I30,I58,
     $             I70,I200,ITMP,IS,IX,IB,IC,IE,IQ,ID,II,I,
     $             J,K,L,DOCFLG,DOCPOS,EXTFLG,EQLFLG,UPDCNT,
     $             NUMUSE,GRPPOS,IAD,ADNFLG,ARCNT,
     $             ARDPOS, IOSTA0,
     $             FINP,FCALL,FNAM,FARG,FCUSE,FDOC,FADEF,FCOUT,
     $             UPDVAR, PTHLEN, ISTART, IPOS1, OPOS1,
     $             ARDSTR(MXNAME), ARDCSP(MXNAME), UPDTYP(MXNAME)
      CHARACTER*1  BUFF(100),TFL(8),SREF(12),FREF(12),
     $             MREF(9),SOUR(8),BLNK(1),
     $             CMNAM(8),VNAM(8),PLUS(3),
     $             BXREF(12),TNAM(6),RPAR,LPAR,
     $             COMMA,VTYPE(30),ARDEF(8), EXREF(12),
     $             OBUFF(58),PURP(6),IMOFG,
     $             LTRB(1), LTRA(1), LTRI(1),
     $             ARDOC(62,MXDEFN), ARNAM(8,MXNAME),
     $             DOCBUF(70,MXPURP), UPDNAM(6,MXNAME)
      CHARACTER*64 FNAME, XNAME, SRTNAM, PATH
      LOGICAL      MAKEX, GETOUT, ASKUSR, BLNKFN, FIRST
C
C     + + + FUNCTIONS + + +
      INTEGER      STRFND,LENSTR,CHRINT
C
C     + + + INTRINSICS + + +
      INTRINSIC    IABS
C
C     + + + EXTERNALS + + +
      EXTERNAL     STRFND, LENSTR, CHRINT, ZIPC, CHRCHR, VUSE,
     +             ADDVAR, MAKXRF, ZIP, PULNAM
C
C     + + + DATA INITIALIZATIONS + + +
      DATA MREF /'M','A','I','N',' ','P','R','O','G'/
      DATA SREF /'S','U','B','R','O','U','T','I','N','E',' ','R'/
      DATA FREF /'F','U','N','C','T','I','O','N',' ','R','E','F'/
      DATA ARDEF/'+',' ','+',' ','A','R','G','U'/
      DATA BLNK /' '/
      DATA LTRB /'B'/
      DATA LTRA /'A'/
      DATA LTRI /'I'/
      DATA RPAR /')'/
      DATA LPAR /'('/
      DATA COMMA/','/
      DATA PURP /'P','U','R','P','O','S'/
      DATA PLUS /'+',' ','+'/
      DATA BXREF/'B','E','G','I','N',' ','C','R','O','S','S',' '/
      DATA EXREF/'E','N','D',' ','C','R','O','S','S',' ','R','E'/
      DATA I2,I3,I6,I8,I10,I12,I28,I30,I58,I70,I200
     &    / 2, 3, 6, 8, 10, 12, 28, 30, 58, 70, 200/
C
C     + + + INPUT FORMATS + + +
 1000 FORMAT (A64)
 1010 FORMAT (100A1)
C
C     + + + OUTPUT FORMATS + + +
 2000 FORMAT (1X,8A1,4X,2(1X,8A1),I3,2X,A1)
 2010 FORMAT (1X,8A1,5X,8A1,I3,2X,A1)
 2020 FORMAT (1X,8A1,5X,I2,2X,8A1,2X,A1,2X,30A1)
 2030 FORMAT (1X,8A1,4X,3(1X,8A1),I3,2X,A1)
 2040 FORMAT (1X,8A1,4X,70A1)
 2050 FORMAT (1X,8A1,4X,58A1,3X,8A1)
 2070 FORMAT (' Building Cross Reference Files')
 2075 FORMAT (' Building Intermediate Processing Files')
 2100 FORMAT (/,' Unable to create valid source code cross reference')
C2200 FORMAT (' Error from DOCDEL when attempting to delete file',/,
C    +        ' File name = ',A)
 2300 FORMAT (' Enter source code file name or <CR> to end input')
 2350 FORMAT (A64)
C
C     + + + END SPECIFICATIONS + + +
C
      GETOUT = .FALSE.
      ASKUSR = .FALSE.
      FINP = 10
      FCALL= 11
      FCOUT= 12
      FNAM = 13
      FARG = 14
      FCUSE= 15
      FDOC = 16
      FADEF= 17
C
C     open file containing names of source code files to process
      OPEN (UNIT=FINP, FILE=CINP,STATUS='OLD', IOSTAT=IOSTA0)
      IF (IOSTA0 .NE. 0) THEN
C       problem opening file, assume it will be built
        ASKUSR = .TRUE.
        OPEN (UNIT=FINP, FILE=CINP, IOSTAT=IOSTA0)
      END IF
C
C     open files to output info to
      OPEN (UNIT=FCALL,FILE=CCALL)
      OPEN (UNIT=FNAM, FILE=CNAM)
      OPEN (UNIT=FARG, FILE=CARG)
      OPEN (UNIT=FCUSE,FILE=CCUSE)
      OPEN (UNIT=FDOC, FILE=CDOC)
      OPEN (UNIT=FADEF,FILE=CADEF)
C
 10   CONTINUE
C       read in the names of the source code files to be processed
        BLNKFN = .FALSE.
        CALL ZIP(' ',FNAME)
        IF (ASKUSR) THEN
C         building source file list, ask yser for input file name
          WRITE(*,2300)
          READ (*,1000) FNAME
          IF (FNAME(1:2) .EQ. '  ') THEN
C           no more input from user
            IOSTA0 = -1
          ELSE
C           save to ___.inp for subsequent runs
            WRITE (FINP,2350) FNAME
          END IF
        ELSE
C         get input file name from ___.inp file
          READ (FINP,1000,IOSTAT=IOSTA0) FNAME
        END IF
        IF (IOSTA0.EQ.0) THEN
          CALL PULNAM (FNAME,SOUR,XNAME,SRTNAM,PATH,PTHLEN,MAKEX,ERRCOD)
          IF (ERRCOD .EQ. -2) THEN
C           blank filename
            BLNKFN = .TRUE.
            ERRCOD = 0
          ELSE
            IF (MAKEX) THEN
C             process source code to build the cross reference listing
              WRITE(*,2070)
              CALL MAKXRF (FNAME, SOUR, DINTLN, INTFIL, XNAME, SRTNAM,
     $                     PATH, PTHLEN, ERRCOD)
              IF (ERRCOD .NE. 0) THEN
                GETOUT = .TRUE.
                WRITE(*,2100)
              END IF
            END IF
            IF (.NOT.GETOUT) THEN
C             cross reference successfully generated
              WRITE(*,2075)
              OPEN (UNIT=FCOUT,FILE=XNAME,STATUS='OLD')
              GRPPOS= 0
              DOCFLG= 1
              EQLFLG= 1
              DOCPOS= 0
              EXTFLG= 0
              UPDCNT= 0
              ARCNT = 0
              ARDPOS= 0
              ADNFLG= 0
 30           CONTINUE
C               loop to read records from listing file
                READ (FCOUT,1010,END=800) BUFF
                IF (EXTFLG.EQ.0) THEN
C                 is this a cross reference listing?
                  EXTFLG = STRFND(I12,BUFF,I12,BXREF)
                  IF (EXTFLG.GT.0) THEN
C                   in cross reference listing, set flags
                    DOCFLG= 0
                    EQLFLG= 0
                  END IF
                ELSE  IF (STRFND(I12,BUFF,I12,EXREF) .NE. 0) THEN
C                 end of cross ref, reset flags for next routine
                  EXTFLG= 0
                  DOCFLG= 1
                  EQLFLG= 1
                  UPDCNT= 0
                  ADNFLG= 0
                  ARCNT = 0
                  ARDPOS= 0
                END IF
C
                IF (DOCFLG.EQ.1) THEN
C                 first section of source code, look for documentation
                  IF (STRFND(I28,BUFF(2),I3,PLUS).EQ.0) THEN
C                   we did NOT find '+ +' in column 2 or beyond of the
C                   source code therefore we are still in the documentation
C                   and arg list section of the xref file.  Note that we
C                   process this section of code regardless of whether or
C                   not we find + + + PURPOSE + + + at the beginning of the
C                   listing file
                    IF (BUFF(1).EQ.'C') THEN
C                     comment statement, could be documentation line
                      IF (LENSTR(25,BUFF(7)) .GT. 2            .AND.
     $                    STRFND(I10,BUFF(7),I10,SREF) .EQ. 0  .AND.
     $                    DOCPOS .LE. MXPURP)                   THEN
C                       there are more than 2 characters on the line
C                       'SUBROUTINE' was not found on the line and there
C                       are still less than 20 lines of documentation
C                       therefore, this line has documentation, store it
C
C                       NOTE that the use of SREF in the above IF statement
C                       does not appear to use SREF for its intended purpose.
C                       SREF is 'SUBROUTINE R' which is 12 characters long
C                       and is used to locate this string in the XREF portion
C                       of the listing.  As used above, only the first 10
C                       characters are used for comparison, therefore the code
C                       is only looking for the word 'SUBROUTINE' beginning in
C                       column 7 of the source code.
C
C                       NOTE:  should this also check for program and
C                              function?  Or should it not check for
C                              subroutine?  This IS a comment line.
C
                        DOCPOS= DOCPOS+ 1
C
C                       find first non-blank character after column 1
                        IPOS1  = 1
                        ISTART = 1
                        FIRST  = .TRUE.
 50                     CONTINUE
                          IPOS1 = ISTART + IPOS1
                          OPOS1 = IPOS1
                          ISTART = STRFND(25,BUFF(IPOS1),1,BLNK)
                          IF (FIRST) THEN
                            FIRST = .FALSE.
                          ELSE IF (IPOS1+ISTART .GT. OPOS1+1) THEN
                            ISTART = 0
                          END IF
                        IF (ISTART .NE. 0) GOTO 50
                        ISTART = OPOS1
                        IF (ISTART .GT. 7) ISTART = 7
                        IF (ISTART .EQ. 0) ISTART = 2
C                       transfer contents of BUFF into DOCBUF
                        CALL CHRCHR (I70,BUFF(ISTART),DOCBUF(1,DOCPOS))
                      END IF
                    ELSE IF (BUFF(6).NE.BLNK(1)) THEN
C                     dummy argument list, assume first argument is input
                      UPDVAR = 1
 60                   CONTINUE
                        IF (BUFF(6) .EQ. 'M') THEN
C                         modify argument
                          UPDVAR = 2
                        ELSE IF (BUFF(6) .EQ. 'O') THEN
C                         output argument
                          UPDVAR = 3
                        END IF
C
                        J= 6
C                       J is a character position counter which is set
C                       to the offset value of 6 to start the process of
C                       scanning the executable source code lines ( i.e.
C                       those lines beginning in column 7) contained in
C                       the xref listing.
C
 65                     CONTINUE
C
                          K= 0
C                         K is used as a counter which is incremented
C                         as additional alphanumeric characters are found
C                         which comprise the name of a variable.
C
                          L= 0
C                         L is a flag which is set to -1 when a comma has
C                         been found which signals this routine to write
C                         out an argument name to the character array
C                         list UPDNAM
C
                          CALL ZIPC (I6,BLNK(1),TNAM)
C                         blank fill TNAM ... TNAM is ( char*1 TNAM(6))
C                         and is used to temporarily store variable names
C                         found in the argument list of the routine being
C                         processed
C
 70                       CONTINUE
                            J = J + 1
C                           first iteration J is set to 7, i.e. the first
C                           character of the source code in the xref listing
                            IF (BUFF(J).EQ.LPAR.OR.BUFF(J).EQ.RPAR) THEN
C                             parenthsis found, dont do anything
                              L= 0
                            ELSE IF (BUFF(J).EQ.COMMA.AND.L.EQ.0) THEN
C                             a comma was found, end of this variable name
                              L= -1
                            ELSE IF (BUFF(J).NE.BLNK(1).AND.L.EQ.0) THEN
C                             a character of a variable name was found
C                             increment the value of K and add the new
C                             character to the TNAM buffer
                              K= K+ 1
                              TNAM(K)= BUFF(J)
                            END IF
                          IF (L.GE.0.AND.J.LT.86.AND.K.LT.6) GO TO 70
C                         a comma was not found, we are not yet at the
C                         end of the line, and the variable name we are
C                         building is less than 6 characters, therefore,
C                         go get the next character and process it.
C
                          IF (K.GT.0) THEN
C                           we found a comma, or end of line, or the
C                           variable name we are attempting to build has
C                           reached 6 characters in length AND K is
C                           greater than 0 therefore we were successful
C                           in building a variable name.
                            CALL ADDVAR (I6,I200,TNAM,UPDVAR,
     M                                   UPDCNT,UPDTYP,UPDNAM)
C                           add the varable name to the list (array UPDNAM)
C                           addvar returns the number (UPDCNT) of variables
C                           stored so far
                          END IF
C
                        IF (BUFF(J).NE.RPAR.AND.J.LT.86) GO TO 65
C                       loop to find more variables until a right
C                       parenthesis is found
C
                        READ (FCOUT,1010,END=800) BUFF
C                       end of line was reached or right paren was found
C                       go get next line
C
                      IF (BUFF(6).NE.BLNK(1)) GO TO 60
C                     if line is a continuation line, look for more
C                     arguments
C
                    END IF
                  ELSE
C                   found "+ +', look for + + + purpose + + +
                    I= STRFND(I28,BUFF(2),I6,PURP)
                    IF (I.EQ.0) THEN
C                     not purpose, no more documentation
                      DOCFLG= 0
                    END IF
                  END IF
                END IF
C
                IF (ADNFLG.EQ.0) THEN
C                 look for + + + argument definitions + + +
                  IAD= STRFND (I10,BUFF(9),I8,ARDEF)
                  IF (IAD.GT.0) THEN
C                   write out definitions of arguments
 35                 CONTINUE
C                     get next line and check for a blank comment
                      READ (FCOUT,1010,END=800) BUFF
                      IF (LENSTR(I58,BUFF(3)).EQ.0) THEN
C                       blank lines are NOT allowed in the arg def section
C                       if a blank line is encountered argument definitions
C                       are finished
                        ADNFLG= 1
                      ELSE
C                       definition, increment counter, save defn & length
                        ARDPOS= ARDPOS+ 1
                        CALL CHRCHR (I58,BUFF(15),ARDOC(1,ARDPOS))
                        ARDCSP(ARDPOS)= LENSTR(I58,ARDOC(1,ARDPOS))
                        IF (BUFF(7).NE.BLNK(1)) THEN
C                         if column 7 of the source code is non-blank,
C                         an argument has been found.  increment the
C                         argument counter and add the argument (i.e. the
C                         variable) name to the argument name array - ARNAM
                          ARCNT= ARCNT+ 1
                          CALL CHRCHR (I8,BUFF(7),ARNAM(1,ARCNT))
                          ARDSTR(ARCNT)= ARDPOS
                        END IF
                      END IF
C                     are there more definitions?
                    IF (ADNFLG.EQ.0) GO TO 35
C                   set termination flag of 9999
                    ARDSTR(ARCNT+1)= 9999
                  END IF
                END IF
                IF (EXTFLG.GT.0) THEN
C                 cross ref portion of the listing
C                 look for 'MAIN PROGRAM'
                  IE= STRFND(9,BUFF(14),9,MREF)
C                 look for 'SUBROUTINE'
                  IS= STRFND(10,BUFF(14),10,SREF)
C                 look for 'FUNCTION'
                  IX= STRFND(60,BUFF(14),8,FREF)
C                 look for common block, B in column 34
                  IC= STRFND(1,BUFF(34),1,LTRB)
C                 look for dummy argument, A in column 34
                  ID= STRFND(1,BUFF(34),1,LTRA)
C                 look for common block name, column 38
                  IF (BUFF(38) .NE. ' ') IB= 1
C                 look for intrinsic, I in column 34
                  II= STRFND(1,BUFF(34),1,LTRI)
C                 find MAIN PROGRAM, SUBROUTINE, FUNCTION or COMMON BLOCK
                  IQ= IE+ IS+ IX+ IC
                  IF ( IS.GT.0 .OR. IX.GT.0 .OR. IE.GT.0) THEN
C                   found  MAIN PROGRAM, SUBROUTINE or FUNCTION, save name
                    CALL CHRCHR (I8,BUFF,TFL)
C                   increment  counter for routine number
                    GRPPOS= GRPPOS + 1
                    IF (IE .NE. 0) THEN
C                     write out information about main program
                      BUFF(14) = 'E'
                      WRITE (*,2010)    TFL,SOUR,GRPPOS,BUFF(14)
                      WRITE (FNAM,2010) TFL,SOUR,GRPPOS,BUFF(14)
                    ELSE IF (IC .NE. 0) THEN
C                     write out information about common block
                      BUFF(34) = 'C'
                      WRITE (*,2010) TFL,SOUR,GRPPOS,BUFF(34)
                      WRITE (FNAM,2010) TFL,SOUR,GRPPOS,BUFF(34)
                    ELSE
C                     write out information about subroutine or function
                      WRITE (*,2010)    TFL,SOUR,GRPPOS,BUFF(14)
                      WRITE (FNAM,2010) TFL,SOUR,GRPPOS,BUFF(14)
                    END IF
                    IF (DOCPOS.GT.0) THEN
C                     save documentation to doc file
                      DO 90 K= 1,DOCPOS
                        WRITE (FDOC,2040) TFL,(DOCBUF(I,K),I=1,70)
 90                   CONTINUE
C                     reset docpos for next routine
                      DOCPOS= 0
C                     save argument definitions to adef file
                      I= 1
                      DO 100 J=1,ARDPOS
                        IF (ARDSTR(I+1).LE.J) THEN
C                         time to write out the next argument
                          I= I+ 1
                        END IF
                        CALL ZIPC (I58,BLNK(1),OBUFF)
                        CALL CHRCHR (ARDCSP(J),ARDOC(1,J),OBUFF)
                        WRITE (FADEF,2050) (ARNAM(K,I),K=1,8),OBUFF,TFL
 100                  CONTINUE
                    END IF
                  ELSE IF (BUFF(34) .EQ. 'X') THEN
C                   external routine, save infor to call file
                    BUFF(34) = 'S'
                    WRITE (FCALL,2000) (BUFF(I),I=1,8),
     $                                 TFL,SOUR,GRPPOS,BUFF(34)
                  ELSE IF (BUFF(34) .EQ. 'I') THEN
C                   intrinsic, save info to call file
                    WRITE (FCALL,2000) (BUFF(I),I=1,8),
     $                                 TFL,SOUR,GRPPOS,BUFF(34)
                  ELSE IF (IC .NE. 0) THEN
C                   common block, save info to the call file
                    BUFF(34) = 'C'
                    WRITE (FCALL,2000) (BUFF(I),I=1,8),
     $                                 TFL,SOUR,GRPPOS,BUFF(34)
                  ELSE IF (BUFF(34) .EQ. 'A') THEN
C                   dummy argument, count uses (name, type & position)
                    CALL CHRCHR (I8,BUFF,VNAM)
                    CALL ZIPC (I30,BLNK(1),VTYPE)
                    CALL CHRCHR (16,BUFF(63),VTYPE)
                    ITMP= CHRINT(LENSTR(3,BUFF(51)),BUFF(51))
                    CALL VUSE (I2,VNAM,UPDCNT,UPDTYP,UPDNAM,FCOUT,
     I                         BUFF,
     O                         NUMUSE,IMOFG)
                    IF (ITMP.GT.0) THEN
C                     save dummy argument info to the arg file
                      WRITE (FARG,2020) TFL,ITMP,VNAM,IMOFG,VTYPE
                    END IF
                  ELSE IF (BUFF(38) .NE. ' ') THEN
C                   common variable, count number of uses
                    CALL CHRCHR (I8,BUFF(1),VNAM)
                    CALL VUSE (1,VNAM,UPDCNT,UPDTYP,UPDNAM,FCOUT,
     M                         BUFF,
     O                         NUMUSE,IMOFG)
                    IF (IMOFG .NE. 'X') THEN
C                     save common info to the common use file
                      CALL CHRCHR (I8,BUFF(38),CMNAM)
                      WRITE (FCUSE,2030) TFL,CMNAM,VNAM,SOUR,
     $                                   GRPPOS,IMOFG
                    END IF
                  END IF
                END IF
C               more records to read
              GOTO 30
 800          CONTINUE
C
              CLOSE (UNIT=FCOUT)
C
C             the following line may be uncommented if you want SYSDOC
C             to automatically delete .XRF files after running except
C             in the event that debug mode is turned on in the OPT.SD file.
CBS           IF (DEBUG .EQ. 0) THEN
CBS             CALL DOCDEL (XNAME, ERRCOD)
CBS             IF (ERRCOD .NE. 0) WRITE (*,2200) XNAME
CBS           END IF
            END IF
          END IF
        END IF
C
C     more source code or xref listing files to read
      IF (.NOT.GETOUT .AND. (IOSTA0 .EQ. 0 .OR. BLNKFN) ) GO TO 10
C
      CLOSE (UNIT=FINP)
      CLOSE (UNIT=FCALL)
      CLOSE (UNIT=FNAM)
      CLOSE (UNIT=FARG)
      CLOSE (UNIT=FCUSE)
      CLOSE (UNIT=FDOC)
      CLOSE (UNIT=FADEF)
C
      RETURN
      END
C
C
C
      SUBROUTINE   VUSE
     I                  (CMNFG,VNAM,UPDCNT,UPDTYP,UPDNAM,FCOUT,
     I                   BUFF,
     O                   NUMUSE,IMOFG)
C
C     + + + PURPOSE + + +
C     Routine to determine the updating of any variables.
C     This routine gathers information from the xref portion
C     of the compiler output listings.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     CMNFG,NUMUSE,UPDCNT,UPDTYP(UPDCNT),FCOUT
      CHARACTER*1 VNAM(8),BUFF(100),UPDNAM(6,UPDCNT),IMOFG
C
C     + + + ARGUMENT DEFINITIONS + + +
C     CMNFG  - common flag 1-variable in common
C            -             2-in argument list
C     VNAM   - variable name from cross-reference listing
C     UPDCNT - maximum number of variables updated
C     UPDTYP - type of update
C     UPDNAM - names of variables updated
C     FCOUT  - name of file containing compiler output
C     BUFF   - buffer containing line from cross reference listing
C     NUMUSE - number of times VNAM is used, excluding declarations
C     IMOFG  - string indicating if variable is input(I),
C              output(M), modify(M), argument(A), or unknown(?)
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     I6,NAMPOS,NUMM
C
C     + + + FUNCTIONS + + +
      INTEGER   CHRINT,CHKSTR
C
C     + + + EXTERNALS + + +
      EXTERNAL  CHRINT, CHKSTR
C
C     + + + DATA INITIALIZATIONS + + +
      DATA I6/6/
C
C     + + + END SPECIFICATIONS + + +
C
      IMOFG= '?'
C     set variable usage flag to unknown until determined otherwise
C
C     find position of name in update array
      IF (UPDCNT.GT.0) THEN
        NAMPOS = CHKSTR (I6,UPDCNT,VNAM,UPDNAM)
      ELSE
C       no vars in array
        NAMPOS = 0
      END IF
C
      NUMUSE = CHRINT(3,BUFF(55))
      NUMM   = CHRINT(3,BUFF(59))
C
      IF (BUFF(49) .EQ. 'A' .AND. CMNFG.EQ.1) THEN
C     common variable being processed is used as an argument in a
C     call to another routine
        IMOFG= 'A'
      END IF
C
      IF (IMOFG.EQ.'?') THEN
C       not used as argument, how was it used?
        IF (CMNFG.EQ.1) THEN
C         variable was used in a common block, base on counts from above
          IF (NUMM .EQ. 0 .AND. NUMUSE .EQ. 0) THEN
C           variable was not used in this routine
            IMOFG = 'X'
          ELSE IF (NUMM.EQ.0) THEN
C           this variable is not updated in this routine
            IMOFG= 'I'
          ELSE IF (NUMM.LT.NUMUSE) THEN
C           this variable is modified
            IMOFG= 'M'
          ELSE IF (NUMUSE.GE.0) THEN
C           this variable is output
            IMOFG= 'O'
          END IF
        ELSE IF (NAMPOS.GT.0) THEN
C         base on argument list
          IF (UPDTYP(NAMPOS).EQ.1) THEN
C           argument is input to routine being processed
            IMOFG= 'I'
          ELSE IF (UPDTYP(NAMPOS).EQ.2) THEN
C           argument is modified in routine being processed
            IMOFG= 'M'
          ELSE IF (UPDTYP(NAMPOS).EQ.3) THEN
C           argument is output from routine being processed
            IMOFG= 'O'
          END IF
        ELSE
C         code does not follow OSW coding convention set to '?'
          IMOFG= '?'
C
C         the following code may be uncommented to have SYSDOC take
C         a best guess as to the use of an argument
C         IMOFG= 'I'
C         IF (NUMM .GT. 0 .OR. NUMUSE .GT. 0) IMOFG = 'M'
        END IF
      END IF
C     IF (NAMPOS.GT.0) THEN
C     WRITE (*,2000) VNAM,IMOFG,NAMPOS,NUMUSE,NUMM,NUMA,UPDTYP(NAMPOS)
C     ELSE
C       WRITE (*,2000) VNAM,IMOFG,NAMPOS,NUMUSE,NUMM,NUMA
C     END IF
C2000 FORMAT (1X,8A1,2X,A1,2X,5I5)
C
      RETURN
      END
C
C
C
      SUBROUTINE   ADDVAR
     I                    (MXLNAM,MXNAM,TNAM,UPDVAR,
     M                     UPDCNT,UPDTYP,UPDNAM)
C
C     + + + PURPOSE + + +
C     Routine to store a variable name found in argument list
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER     MXLNAM,MXNAM,UPDVAR,UPDCNT,UPDTYP(MXNAM)
      CHARACTER*1 TNAM(6),UPDNAM(MXLNAM,MXNAM)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MXLNAM - maximum length of names
C     MXNAM  - maximum number of names
C     TNAM   - name of variable to store
C     UPDVAR - type of variable 1-I,2-M,3-O
C     UPDCNT - number of variables stored
C     UPDTYP - type of argument
C     UPDNAM - names of variables stored
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     J
C
C     + + + FUNCTIONS + + +
      INTEGER     CHKSTR
C
C     + + + EXTERNALS + + +
      EXTERNAL    CHKSTR,CHRCHR
C
C     + + + END SPECIFICATIONS + + +
C
      IF (UPDCNT.GT.0) THEN
C       see if we already have this name
        J= CHKSTR (MXLNAM,UPDCNT,TNAM,UPDNAM)
      ELSE
C       dont have any names yet
        J= 0
      END IF
C
      IF (J.EQ.0) THEN
C       store the new name
        UPDCNT= UPDCNT+ 1
        CALL CHRCHR (MXLNAM,TNAM,UPDNAM(1,UPDCNT))
        UPDTYP(UPDCNT)= UPDVAR
      ELSE
C       update type for name
        UPDTYP(J)= UPDVAR
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   BNAM
     I                 (CSARG,CSADEF,CFARG)
C
C     + + + PURPOSE + + +
C     Routine to list arguments in alpha order with calling
C     routines also condenses type.
C
C     + + + DUMMY ARGUMENTS + + +
      CHARACTER*14 CSARG,CSADEF,CFARG
C
C     + + + ARGUMENT DEFINITIONS + + +
C     CSARG  - name of file containing names of arguments
C     CSADEF - name of file containing definitions of variables
C     CFARG  - name of file containing variable names and
C              definitions if available
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      APOS,SKIPA,DBLK,IOSTA0,
     &             FSARG,FSADEF,FFARG
      CHARACTER*1  ATYP(30),CTYP(12),BLNK(1),AIMO
      CHARACTER*1  VVAR1(8)
      CHARACTER*1  VDEF1(58)
      CHARACTER*8  ASOUR,AVAR,VSOUR,VVAR
      CHARACTER*58 VDEF
      LOGICAL      GETOUT, NODEFS, NOARGS
C
C     + + + EQUIVALENCES + + +
      EQUIVALENCE (VDEF,VDEF1)
      EQUIVALENCE (VVAR,VVAR1)
C
C     + + + EXTERNALS + + +
      EXTERNAL     ZIPC, CHRCHR
C
C     + + + DATA INITIALIZATIONS + + +
      DATA BLNK/' '/
C
C     + + + INPUT FORMATS + + +
 1020 FORMAT (1X,A8,4X,A58,3X,A8)
 1030 FORMAT (1X,A8,5X,I2,2X,A8,2X,A1,2X,30A1)
C
C     + + + OUTPUT FORMATS + + +
 2000 FORMAT (1X,A8,5X,I2,2X,A8,2X,A1,2X,12A1,2X,A58)
 2010 FORMAT (1X,A8,5X,I2,2X,A8,2X,A1,2X,12A1,2X,
     +        '*** Need Argument Definition ***')
C 2900 FORMAT (1X,'V:',A8,1X,A8,' A:',A8,1X,A8,' ** DEF WITH NO ARG **')
C 2910     FORMAT (1X,'V:',A8,1X,A8,' A:',A8,1X,A8,' ** NO DEF **')
 2920 FORMAT (/,1X,'Routine ',A8,' contains an ARGUMENT DEFINITION for',
     +        /,' an argument that does not exist - ',A8,/)
 2930 FORMAT (/,1X,'Routine ',A8,' contains an argument which is ',/,
     +        ' not defined in the ARGUMENT DEFINITION section',/,
     +        ' of the source code - ARGUMENT = ',A8,/)
C
C
C     + + + END SPECIFICATIONS + + +
C
      GETOUT = .FALSE.
      NODEFS = .FALSE.
      NOARGS = .FALSE.
      FSARG = 14
      FSADEF= 15
      FFARG = 16
      OPEN (UNIT=FSARG, FILE=CSARG, STATUS='OLD')
      OPEN (UNIT=FSADEF,FILE=CSADEF,STATUS='OLD')
      OPEN (UNIT=FFARG, FILE=CFARG)
C
      READ (FSADEF,1020, IOSTAT=IOSTA0) VVAR,VDEF,VSOUR
      IF (IOSTA0 .NE. 0) THEN
C       no argument definitions available
        VVAR   = 'ZZZZZZZZ'
        VSOUR  = 'ZZZZZZZZ'
        NODEFS = .TRUE.
      END IF
      CALL ZIPC(2,BLNK(1),VVAR1(7))
      SKIPA= 0
 20   CONTINUE
        IF (SKIPA.EQ.0) THEN
C         read next argument
          READ (FSARG,1030,IOSTAT=IOSTA0) ASOUR,APOS,AVAR,AIMO,ATYP
          IF (IOSTA0 .NE. 0) THEN
C           no arguments
            ASOUR  = 'AAAAAAAA'
            AVAR   = 'AAAAAAAA'
            NOARGS = .TRUE.
            IF (NODEFS) GETOUT = .TRUE.
          END IF
        END IF
        IF (.NOT.GETOUT) THEN
C         condense ATYP into CTYP
          CALL CHRCHR (12, ATYP(1), CTYP)
          SKIPA= 0
          IF (VVAR.EQ.AVAR.AND.VSOUR.EQ.ASOUR) THEN
C           write the variable and its def
 70         CONTINUE
              DBLK= 1
 72           CONTINUE
                IF (VDEF1(DBLK).EQ.BLNK(1)) THEN
C                 CALL CHRDEL (I58,I1,VDEF1)
                  DBLK= DBLK+ 1
                END IF
              IF (VDEF1(DBLK).EQ.BLNK(1).AND.DBLK.LT.58) GO TO 72
              IF (DBLK.LT.58) THEN
C               only write defs with text
                WRITE (FFARG,2000) ASOUR,APOS,AVAR,AIMO,CTYP,VDEF
              END IF
              READ (FSADEF,1020,IOSTAT=IOSTA0) VVAR,VDEF,VSOUR
              IF (IOSTA0 .NE. 0) THEN
C               end of argument def file
                VVAR= 'ZZZZZZZZ'
                NODEFS = .TRUE.
                IF (NOARGS) GETOUT = .TRUE.
              END IF
              CALL ZIPC(2,BLNK(1),VVAR1(7))
            IF (VVAR.EQ.AVAR.AND.VSOUR.EQ.ASOUR) GO TO 70
          ELSE IF (VVAR .LT. AVAR .OR.
     +            (VVAR .EQ. AVAR .AND. VSOUR .LT. ASOUR)) THEN
C           no argument for given definition
            SKIPA= 1
            WRITE (*,2920) VSOUR, VVAR
            READ  (FSADEF,1020,IOSTAT=IOSTA0) VVAR,VDEF,VSOUR
            IF (IOSTA0 .NE. 0) THEN
C             end of argument def file
              VVAR= 'ZZZZZZZZ'
              NODEFS = .TRUE.
              IF (NOARGS) GETOUT = .TRUE.
            END IF
            CALL ZIPC (2,BLNK(1),VVAR1(7))
          ELSE
C           write the variable and no def
            WRITE (FFARG,2010) ASOUR,APOS,AVAR,AIMO,CTYP
            WRITE (*,2930) ASOUR, AVAR
          END IF
        END IF
      IF (.NOT.GETOUT) GO TO 20
C
      CLOSE (UNIT=FSARG)
      CLOSE (UNIT=FSADEF)
      CLOSE (UNIT=FFARG)
C
      RETURN
      END
