C
C     Definitions of the variables contained in COMMON XREFC and XREFI
C
C     MODULE is the array that contains the program unit name.  In
C     other words, the name of the main program, the subroutine, or
C     the function which is being processed.
C
C     MODTYP is the array that contains the program unit type.
C     Valid MODTYP's are:
C              'M' = main routine
C              'S' = subroutine
C              'F' = function
C              'D' = double precision function
C              'R' = real function
C              'I' = integer function
C              '2' = integer*2 function
C              '4' = integer*4 function
C              'J' = integer*? function
C              'C' = character function
C              'L' = logical function
C              'X' = complex function
C
C
C     MODNUM is the relative location of the MODULE in the source
C     file being processed.  For example, if a source code file
C     contains five routines (Progams and/or Subroutines and/or
C     Functions) each of the five routines will be assigned its
C     location as MODNUM = 1 through 5.
C
C     ARGCNT is the number of dummy arguments associated with the
C     module name in the corresponding MODULE array element.
C
C     SYMNAM contains the names of all symbols found in the source
C     file module.  Example symbols are:
C
C           Variable Names
C           Format Label Numbers
C           Executable Label Numbers
C           Called routine names (Subroutines/Functions/Intrinsics)
C           Common block names
C
C     CLASS contains a character flag representing the class of the
C     symbol.  Examples are:
C
C           C = Constant
C           S = Static
C           D = Dynamic
C           B = Common Block
C           A = Dummy Argument
C           I = Intrinsic
C           X = External
C
C     DEFIND contains a logical flag which is TRUE if the SYMBOL
C     was defined in the line which it was found and FALSE otherwise.
C
C     ATRIB1 contains attributes of the symbols.  For example:
C
C           E = Executable Label Line
C           F = Format Label Line
C           C = Character
C           I = Integer
C           R = Real
C           X = Complex
C           L = Logical
C           D = Double Precision
C
C     ATRIB2 contains the assigned variable length. For example:
C
C           Character*4   = 4
C           Integer       = 0
C           Real*8        = 8
C           Complex*16    = 16
C           Character*(*) = -1 to signal xref system that this
C                           variable assumes argument length
C
C     ATRIB3 contains additional attributes about the symbol
C
C           E = Entry Point (Main Program)
C           F = Function
C           S = Subroutine
C           I = Initialized
C           P = Parameter
C           N = Not Used
C           L = Label Number
C
C     DIM1, DIM2, DIM3, DIM4 contain the array dimensions of the
C     symbol if it is an array.  This program handles up to a
C     four dimensional array.
C
C     COMNAM contains the name of the common block in which it is
C     used if appropriate.
C
C     LINENO contains the source code line number in which the
C     symbol was found.  All symbols found in INCLUDE or $INSERT
C     files will be given the line number on which the INCLUDE or
C     $INSERT statement was found.
C
C     LINUSE contains a one character flag which indicates how the
C     symbol was used on the line being processed.  For example:
C
C           A = Argument.  Symbol was used as an argument when
C               calling another routine.
C
C           M = Modified.  Symbol was found to the left of an
C               '=' sign.
C
C           C = Common.  Symbol was contained in a common block.
C
C     ARGPOS contains the position of the symbol in dummy argument
C     list of the routine being processed.
C
C     NUMUSE contains the number of times the variable was used
C     as an argument when calling a subroutine from the module
C     being processed
C
C     NUMM contains the number of times the variable was modified
C

