C
C
C
      SUBROUTINE   FNDEXT
     O                   (NXTFLG, ERRCOD)
C
C     + + + PURPOSE + + +
C     routine to capture information about EXTERNAL routines
C     used in source code modules
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER ERRCOD
      LOGICAL NXTFLG
C
C     + + + ARGUMENT DEFINITIONS + + +
C     NXTFLG - flag to tell calling routine that no additional
C              tokens in the token buffer need to be processed
C              .TRUE. if processing of current buffer is complete
C              .FALSE. otherwise
C     ERRCOD - error code returned to calling program
C               0 - operation was successful
C              -1 - operation failed
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'ctokeb.inc'
      INCLUDE 'ctokec.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER ERRFLG
      LOGICAL MOREXT
C
C     + + + EXTERNALS + + +
      EXTERNAL ERROUT, DUMPBF, BUMPTK, CLTBUF, XTBUF
C
C     + + + END SPECIFICATIONS + + +
C
      ERRCOD = 0
      NXTFLG = .FALSE.
      CALL CLTBUF
      TLINEN = PRLINE
C
C     set class equal to eXternal
      TCLASS = 'X'
C
C     loop to get name of EXTERNAL routines
 100  CONTINUE
        CALL BUMPTK(1,ERRFLG)
        IF (ERRFLG .EQ. 0) THEN
C         process token
          IF (TOKEN(1:TOKLEN) .EQ. ',') THEN
            MOREXT = .TRUE.
          ELSE IF (TTYPE .EQ. 'C') THEN
C           found a character string
            IF (TOKEN(1:TOKLEN) .EQ. 'NONE') THEN
C             no EXTERNALS
              MOREXT = .FALSE.
              NXTFLG = .TRUE.
            ELSE
C             found an external routine
              TSYMNM = TOKEN(1:TOKLEN)
              SYMNUM = SYMNUM + 1
              CALL XTBUF
              MOREXT = .TRUE.
            END IF
          ELSE
C           found non-character string or illegal delimeter
            ERRCOD = -1
            CALL ERROUT(' Error in FNDEXT','FNDCOM')
            CALL DUMPBF
            MOREXT = .FALSE.
          END IF
        ELSE
C         no more tokens
          NXTFLG = .TRUE.
          MOREXT = .FALSE.
        END IF
      IF (MOREXT) GOTO 100
      RETURN
      END
C
C
C
      SUBROUTINE   LDINTR
     I                   (INTFIL,
     O                    ERRCOD)
C
C     + + + PURPOSE + + +
C     routine to load compiler specific INTRINSICs
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER ERRCOD
      CHARACTER*(*) INTFIL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     INTFIL - path name of file containing list of valid INTRINSICS
C     ERRCOD - error code returned to calling program
C               0 - operation was successful
C              -1 - operation failed
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'cintrn.inc'
      INCLUDE 'dintrn.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      TMPUNT, IOSTA1
      LOGICAL      MORINT
C
C     + + + EXTERNALS + + +
      EXTERNAL GUNIT, ERROUT
C
C     + + + INPUT FORMATS + + +
 1000 FORMAT(A6)
C
C     + + + END SPECIFICATIONS + + +
C
      ERRCOD = 0
C     open INTRINS.SD file which contains list of compiler
C     specific INTRINSICs
      CALL GUNIT (TMPUNT, ERRCOD)
      OPEN (UNIT=TMPUNT, FILE=INTFIL, STATUS='OLD',
     +      ACCESS='SEQUENTIAL', IOSTAT=ERRCOD)
      IF (ERRCOD .EQ. 0) THEN
C       file opened successfully
        INTCNT = 0
        MORINT = .TRUE.
 100    CONTINUE
          INTCNT = INTCNT + 1
          READ (TMPUNT, 1000, IOSTAT=IOSTA1) CINTRN(INTCNT)
          IF(IOSTA1 .GT. 0) THEN
C           error during read
            CALL ERROUT (' Error during READ','LDINTR')
            ERRCOD = -1
            MORINT = .FALSE.
            INTCNT = INTCNT - 1
          ELSE IF(IOSTA1 .LT. 0) THEN
C           end of file
            CLOSE (TMPUNT)
            MORINT = .FALSE.
            INTCNT = INTCNT - 1
          END IF
        IF(MORINT) GOTO 100
      ELSE
        CALL ERROUT (' Error in call to OPEN','LDINTR')
        ERRCOD = -1
      END IF
      RETURN
      END
C
C
C
      SUBROUTINE   FNDINT
     O                   (DONFLG, NXTFLG, ERRCOD)
C
C     + + + PURPOSE + + +
C     routine to capture information about INTRINSIC routines
C     used in source code modules
C
C     + + + DUMMY ARGUMENTS + + +
      LOGICAL       NXTFLG, DONFLG
      INTEGER       ERRCOD
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DONFLG - flag to tell calling routine that this routine
C              has located the end of the specification statements
C              in the source code file
C     NXTFLG - flag to tell calling routine that no additional
C              tokens in the token buffer need to be processed
C              .TRUE. if processing of current buffer is complete
C              .FALSE. otherwise
C     ERRCOD - error code returned to calling program
C               0 - operation was successful
C              -1 - operation failed
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'ctokeb.inc'
      INCLUDE 'ctokec.inc'
      INCLUDE 'cintrn.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER LOOP, ERRFLG
      LOGICAL INTFLG, GETOUT, MORINT
C
C     + + + EXTERNALS + + +
      EXTERNAL ERROUT, DUMPBF, CLTBUF, XTBUF, BUMPTK
C
C     + + + OUTPUT FORMATS + + +
 2000 FORMAT(/,' INTRINSIC not defined in Intrins.SD file - ',A,
     +         ' on line ',I5,' in file ',A,/,
     +         ' If this is a valid INTRINSIC, please inform',/,
     +         ' SYSDOC administrator.  Otherwise, please',/,
     +         ' correct it and rerun SYSDOC',/)
C
C     + + + END SPECIFICATIONS + + +
C
      ERRCOD = 0
      GETOUT = .FALSE.
      NXTFLG = .FALSE.
      DONFLG = .FALSE.
      INTFLG = .FALSE.
      CALL CLTBUF
      TLINEN = PRLINE
C
C     set token class equal to INTRINSIC
      TCLASS = 'I'
C
C     get names of INTRINSIC routines
 100  CONTINUE
        MORINT = .FALSE.
        CALL BUMPTK(1,ERRFLG)
        IF (ERRFLG .EQ. 0) THEN
          IF (TTYPE .EQ. 'C') THEN
C           process character string
            IF (TOKEN(1:TOKLEN) .EQ. 'NONE') THEN
C             no INTRINSICS used
              GETOUT = .TRUE.
              MORINT = .FALSE.
              NXTFLG = .TRUE.
            ELSE
C             process INTRINSIC
              LOOP = 0
 200          CONTINUE
                LOOP = LOOP + 1
                IF (LOOP .LE. INTCNT) THEN
C                 there are INTRINSIC names to compare against
                  IF (TOKEN .EQ. CINTRN(LOOP)) THEN
C                   token is an INTRINSIC
                    INTFLG = .TRUE.
                  END IF
                ELSE
C                 no more INTRINSIC names
                  GETOUT = .TRUE.
                END IF
              IF (.NOT.GETOUT .AND. .NOT.INTFLG) GOTO 200
C
              IF (.NOT.GETOUT .AND. INTFLG) THEN
                TSYMNM = TOKEN(1:TOKLEN)
                SYMNUM = SYMNUM + 1
                CALL XTBUF
              ELSE IF(.NOT.GETOUT) THEN
C               found an unregistered INTRINSIC
                WRITE(*,2000) TOKEN(1:TOKLEN), PRLINE, TMODUL
CBS             add new INTRINSIC name to master INTRINSIC list
CBS             INTCNT = INTCNT + 1
CBS             CINTRN(INTCNT) = TSYMNM
              END IF
              MORINT = .TRUE.
            END IF
          ELSE IF (TOKEN(1:TOKLEN) .EQ. ',') THEN
C           found a comma, get next INTRINSIC
            MORINT = .TRUE.
          ELSE
            CALL ERROUT(' Error in FNDINT','FNDINT')
            CALL DUMPBF
            ERRCOD = -1
            GETOUT = .TRUE.
          END IF
        ELSE
C         no more tokens - end-of-line
          NXTFLG = .TRUE.
          GETOUT = .TRUE.
        END IF
      IF (.NOT.GETOUT .AND. MORINT) GOTO 100
      RETURN
      END
C
C
C
      SUBROUTINE   FNDDAT
     O                   (DONFLG, NXTFLG, ERRCOD)
C
C     + + + PURPOSE + + +
C     routine to capture information about variables used in
C     DATA statements
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER  ERRCOD
      LOGICAL  DONFLG, NXTFLG
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DONFLG - flag to tell calling routine that this routine
C              has located the end of the specification statements
C              in the source code file
C     NXTFLG - flag to tell calling routine that no additional
C              tokens in the token buffer need to be processed
C              .TRUE. if processing of current buffer is complete
C              .FALSE. otherwise
C     ERRCOD - error code returned to calling program
C               0 - operation was successful
C              -1 - operation failed
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'cxref.inc'
      INCLUDE 'ctokea.inc'
      INCLUDE 'ctokeb.inc'
      INCLUDE 'ctokec.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER LOOP, SLEVEL, ERRFLG
      LOGICAL GETOUT, NEXT, MORSYM
C
C     + + + INTRINSICS + + +
      INTRINSIC MOD
C
C     + + + EXTERNALS + + +
      EXTERNAL CLTBUF, XTBUF, BUMPTK
C
C     + + + END SPECIFICATIONS + + +
C
      ERRCOD = 0
      NXTFLG = .FALSE.
      DONFLG = .FALSE.
      CALL CLTBUF
      SLEVEL = 0
      TLNUSE = 'M'
      TLINEN = PRLINE
      GETOUT = .FALSE.
      NEXT   = .TRUE.
C     get names of variables in DATA statements
 100  CONTINUE
        CALL BUMPTK(1,ERRFLG)
        IF(ERRFLG .EQ. 0) THEN
C         process token
C         check for slashes
          IF (TOKEN(1:TOKLEN) .EQ. '/') THEN
C           slash encountered
            IF (TKBUFF(TNUM-1) .EQ. 1H' .AND.
     +          TKBUFF(TNUM+1) .EQ. 1H') THEN
C             slash is enclosed in quotations, ignore it, get next token
            ELSE
C             otherwise set the slash level counter
C             the slash level counter is 1 if tokens are inside
C             a set of slashes and 0 otherwise
              SLEVEL = MOD (SLEVEL+1, 2)
            END IF
          ELSE IF (TTYPE .EQ. 'C' .AND. SLEVEL .EQ. 0) THEN
C           token is not a slash and is outside a pair
C           of slashes, therefore it is a variable name
C           find previously captured information about token (symbol)
            LOOP = 0
            MORSYM = .TRUE.
 200        CONTINUE
              LOOP = LOOP + 1
              IF (LOOP .LE. SYMNUM) THEN
C               compare token to symbol
                IF (TOKEN(1:TOKLEN) .EQ. SYMNAM(LOOP)) THEN
C                 found a match
                  TSYMNM = TOKEN(1:TOKLEN)
                  SYMNUM = SYMNUM + 1
C                 write out info to main xref buffer
                  CALL XTBUF
                  MORSYM = .FALSE.
                END IF
              ELSE
C               no more symbols
                MORSYM = .FALSE.
              END IF
            IF (MORSYM) GOTO 200
          END IF
        ELSE
C         no more tokens - end-of-line
          NXTFLG = .TRUE.
          GETOUT = .TRUE.
          NEXT   = .FALSE.
        END IF
      IF (.NOT.GETOUT .AND. NEXT) GOTO 100
      RETURN
      END
