C
C
C
      SUBROUTINE   RWORD (
     I                     CSTRNG,
     O                     RWDFLG,  ERRCOD)
C
C     + + + PURPOSE + + +
C     routine to check character string against list of reserved words
C     if a match is found, RWDFLG is set to .TRUE., otherwise .FALSE.
C
C     + + + DUMMY ARGUMENTS + + +
      CHARACTER*(*) CSTRNG
      LOGICAL       RWDFLG
      INTEGER       ERRCOD
C
C     + + + ARGUMENT DEFINITIONS + + +
C     CSTRNG - character string passed from calling program
C     RWDFLG - flag to indicate if CSTRNG is a reserved word or not
C     ERRCOD - error code returned to calling program
C               0 - operation was successful
C              -1 - operation failed
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'ctokea.inc'
      INCLUDE 'ctokeb.inc'
C
C     + + + END SPECIFICATIONS + + +
C
      RWDFLG = .FALSE.
      ERRCOD = 0
C
C     look for reserved word
      IF (CSTRNG .EQ. '=') RWDFLG = .TRUE.
      IF (CSTRNG .EQ. 'DO') RWDFLG = .TRUE.
      IF (CSTRNG .EQ. 'GO') RWDFLG = .TRUE.
      IF (CSTRNG .EQ. 'IF') RWDFLG = .TRUE.
      IF (CSTRNG .EQ. 'END') RWDFLG = .TRUE.
      IF (CSTRNG .EQ. 'CALL') RWDFLG = .TRUE.
      IF (CSTRNG .EQ. 'ELSE') RWDFLG = .TRUE.
      IF (CSTRNG .EQ. 'THEN') RWDFLG = .TRUE.
      IF (CSTRNG .EQ. 'GOTO') RWDFLG = .TRUE.
      IF (CSTRNG .EQ. 'OPEN') RWDFLG = .TRUE.
      IF (CSTRNG .EQ. 'READ') RWDFLG = .TRUE.
      IF (CSTRNG .EQ. 'STOP') RWDFLG = .TRUE.
      IF (CSTRNG .EQ. 'CLOSE') RWDFLG = .TRUE.
      IF (CSTRNG .EQ. 'END IF') RWDFLG = .TRUE.
      IF (CSTRNG .EQ. 'PRINT') RWDFLG = .TRUE.
      IF (CSTRNG .EQ. 'WRITE') RWDFLG = .TRUE.
      IF (CSTRNG .EQ. 'FORMAT') RWDFLG = .TRUE.
      IF (CSTRNG .EQ. 'ELSE IF') RWDFLG = .TRUE.
      IF (CSTRNG .EQ. 'RETURN') RWDFLG = .TRUE.
      IF (CSTRNG .EQ. 'INQUIRE') RWDFLG = .TRUE.
      IF (CSTRNG .EQ. 'CONTINUE') RWDFLG = .TRUE.
C
      IF (TNUM .GT. 1 .AND. (TNUM+1) .LE. ITEMS) THEN
C       check for .AND.
        IF (CSTRNG .EQ. 'AND' .AND. TKBUFF(TNUM-1) .EQ. '.'
     +       .AND. TKBUFF(TNUM+1) .EQ. '.') RWDFLG = .TRUE.
C
C       check for .GE.
        IF (CSTRNG .EQ. 'GE' .AND. TKBUFF(TNUM-1) .EQ. '.'
     +       .AND. TKBUFF(TNUM+1) .EQ. '.') RWDFLG = .TRUE.
C
C       check for .GT.
        IF (CSTRNG .EQ. 'GT' .AND. TKBUFF(TNUM-1) .EQ. '.'
     +       .AND. TKBUFF(TNUM+1) .EQ. '.') RWDFLG = .TRUE.
C
C       check for .LT.
        IF (CSTRNG .EQ. 'LT' .AND. TKBUFF(TNUM-1) .EQ. '.'
     +       .AND. TKBUFF(TNUM+1) .EQ. '.') RWDFLG = .TRUE.
C
C       check for .EQ.
        IF (CSTRNG .EQ. 'EQ' .AND. TKBUFF(TNUM-1) .EQ. '.'
     +       .AND. TKBUFF(TNUM+1) .EQ. '.') RWDFLG = .TRUE.
C
C       check for .NE.
        IF (CSTRNG .EQ. 'NE' .AND. TKBUFF(TNUM-1) .EQ. '.'
     +       .AND. TKBUFF(TNUM+1) .EQ. '.') RWDFLG = .TRUE.
C
C       check for .LE.
        IF (CSTRNG .EQ. 'LE' .AND. TKBUFF(TNUM-1) .EQ. '.'
     +       .AND. TKBUFF(TNUM+1) .EQ. '.') RWDFLG = .TRUE.
C
C       check for .OR.
        IF (CSTRNG .EQ. 'OR' .AND. TKBUFF(TNUM-1) .EQ. '.'
     +       .AND. TKBUFF(TNUM+1) .EQ. '.') RWDFLG = .TRUE.
C
C       check for .XOR.
        IF (CSTRNG .EQ. 'XOR' .AND. TKBUFF(TNUM-1) .EQ. '.'
     +       .AND. TKBUFF(TNUM+1) .EQ. '.') RWDFLG = .TRUE.
C
C       check for .NOT.
        IF (CSTRNG .EQ. 'NOT' .AND. TKBUFF(TNUM-1) .EQ. '.'
     +       .AND. TKBUFF(TNUM+1) .EQ. '.') RWDFLG = .TRUE.
      END IF
      RETURN
      END
C
C
C
      SUBROUTINE   CKARGS (
     I                      CSTRNG,
     O                      ARGFLG, ERRCOD)
C
C     + + + PURPOSE + + +
C     routine to determine if CSTRNG is a dummy argument name
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER       ERRCOD
      CHARACTER*(*) CSTRNG
      LOGICAL       ARGFLG
C
C     + + + ARGUMENT DEFINITIONS + + +
C     CSTRNG - character string passed from calling routine
C              to be checked against master xref buffer
C     ARGFLG - LOGICAL flag which indicates if a CSTRNG is the
C              name of a dummy argument
C     ERRCOD - error code returned to calling program
C               0 - operation was successful
C              -1 - operation failed
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'cxref.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER SYMLOC, STARTL
      LOGICAL GETOUT
C
C     + + + EXTERNALS + + +
      EXTERNAL FNDSYM
C
C     + + + END SPECIFICATIONS + + +
C
      ERRCOD = 0
      ARGFLG = .FALSE.
      GETOUT = .FALSE.
      SYMLOC = 0
 100  CONTINUE
        STARTL = SYMLOC + 1
        CALL FNDSYM (CSTRNG, STARTL, SYMLOC, ERRCOD)
        IF (ERRCOD .EQ. 0) THEN
C         found symbol
          IF (CLASS(SYMLOC) .EQ. 'A') THEN
C           symbol is an argument
            ARGFLG = .TRUE.
            GETOUT = .TRUE.
          END IF
        ELSE
C         no more symbols to compare
          GETOUT = .TRUE.
        END IF
      IF (.NOT.GETOUT .AND. .NOT.ARGFLG) GOTO 100
      ERRCOD = 0
      RETURN
      END
C
C
C
      SUBROUTINE   CKCOMV (
     I                      CSTRNG,
     O                      CVFLG, ERRCOD)
C
C     + + + PURPOSE + + +
C     routine to determine if CSTRNG is a variable contained
C     in a common block
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER       ERRCOD
      CHARACTER*(*) CSTRNG
      LOGICAL       CVFLG
C
C     + + + ARGUMENT DEFINITIONS + + +
C     CSTRNG - character string passed from calling routine
C              to be checked against master xref buffer
C     CVFLG  - LOGICAL flag which indicates if CSTRNG is a
C              variable contained in a common block
C     ERRCOD - error code returned to calling program
C               0 - operation was successful
C              -1 - operation failed
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'cxref.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      SYMLOC, STARTL
      CHARACTER*10 TCOMN
      LOGICAL      GETOUT
C
C     + + + EXTERNALS + + +
      EXTERNAL FNDSYM
C
C     + + + END SPECIFICATIONS + + +
C
      ERRCOD = 0
      CVFLG  = .FALSE.
      GETOUT = .FALSE.
      SYMLOC = 0
 100  CONTINUE
        STARTL = SYMLOC + 1
        CALL FNDSYM (CSTRNG, STARTL, SYMLOC, ERRCOD)
        IF (ERRCOD .EQ. 0) THEN
C         found a symbol
          TCOMN = COMNAM(SYMLOC)
          IF (TCOMN(1:1) .NE. ' ') THEN
C           symbol is a COMMON variable
            CVFLG  = .TRUE.
            GETOUT = .TRUE.
          END IF
        ELSE
C         no more symbols
          GETOUT = .TRUE.
        END IF
      IF (.NOT.GETOUT .AND. .NOT.CVFLG) GOTO 100
      ERRCOD = 0
      RETURN
      END
C
C
C
      SUBROUTINE   GTCOMV (
     I                      CSTRNG,
     O                      CVFLG, SYMLOC, ERRCOD)
C
C     + + + PURPOSE + + +
C     routine to determine if CSTRNG is a variable contained
C     in a common block
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER       ERRCOD, SYMLOC
      CHARACTER*(*) CSTRNG
      LOGICAL       CVFLG
C
C     + + + ARGUMENT DEFINITIONS + + +
C     CSTRNG - character string passed from calling routine
C              to be checked against master xref buffer
C     CVFLG  - LOGICAL flag which indicates if CSTRNG is a
C              variable contained in a common block
C     SYMLOC - location in main buffer where COMMON variable
C              was found
C     ERRCOD - error code returned to calling program
C               0 - operation was successful
C              -1 - operation failed
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'cxref.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      STARTL
      CHARACTER*10 TCOMN
      LOGICAL      GETOUT
C
C     + + + EXTERNALS + + +
      EXTERNAL FNDSYM
C
C     + + + END SPECIFICATIONS + + +
C
      ERRCOD = 0
      GETOUT = .FALSE.
      CVFLG  = .FALSE.
      SYMLOC = 0
 100  CONTINUE
        STARTL = SYMLOC + 1
        CALL FNDSYM (CSTRNG, STARTL, SYMLOC, ERRCOD)
        IF (ERRCOD .EQ. 0) THEN
C         found a symbol
          TCOMN = COMNAM(SYMLOC)
          IF (TCOMN(1:1) .NE. ' ') THEN
C           symbol is in COMMON
            CVFLG  = .TRUE.
            GETOUT = .TRUE.
          END IF
        ELSE
C         no more symbols to compare
          GETOUT = .TRUE.
        END IF
      IF (.NOT.GETOUT .AND. .NOT.CVFLG) GOTO 100
      ERRCOD = 0
      RETURN
      END
C
C
C
      SUBROUTINE   CKINTR (
     I                      CSTRNG,
     O                      INTFLG, ERRCOD)
C
C     + + + PURPOSE + + +
C     routine to determine if CSTRNG is the name of an INTRINSIC
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER       ERRCOD
      CHARACTER*(*) CSTRNG
      LOGICAL       INTFLG
C
C     + + + ARGUMENT DEFINITIONS + + +
C     CSTRNG - character string passed from calling routine
C              to be checked against master xref buffer
C     INTFLG - LOGICAL flag which indicates if CSTRNG is the
C              name of an INTRINSIC
C     ERRCOD - error code returned to calling program
C               0 - operation was successful
C              -1 - operation failed
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'cxref.inc'
      INCLUDE 'cintrn.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER  SYMLOC, STARTL, LOOP
      LOGICAL  INTFL2, TDEF, MORSYM
C
C     + + + EXTERNALS + + +
      EXTERNAL FNDSYM
C
C     + + + END SPECIFICATIONS + + +
C
      ERRCOD = 0
      INTFLG  = .FALSE.
C
C     see if CSTRNG is already in the main xref buffer
      MORSYM = .TRUE.
      SYMLOC = 0
 100  CONTINUE
        STARTL = SYMLOC + 1
        CALL FNDSYM (CSTRNG, STARTL, SYMLOC, ERRCOD)
        IF (ERRCOD .EQ. 0) THEN
          IF (DEFIND(SYMLOC)) TDEF = .TRUE.
          IF (CLASS(SYMLOC) .EQ. 'I') THEN
            INTFLG = .TRUE.
          END IF
        ELSE
C         no more symbols
          MORSYM = .FALSE.
        END IF
      IF (MORSYM .AND. .NOT.INTFLG) GOTO 100
C
C     also see if it is on master list of INTRINSICs
      MORSYM = .TRUE.
      LOOP = 0
 200  CONTINUE
        LOOP = LOOP + 1
        IF (LOOP .LE. INTCNT) THEN
          IF (CSTRNG .EQ. CINTRN(LOOP)) THEN
            INTFL2 = .TRUE.
             IF (.NOT.INTFLG .AND. .NOT.TDEF) THEN
C             not defined in the master xref list
              INTFLG = .TRUE.
             END IF
          END IF
        ELSE
          MORSYM = .FALSE.
        END IF
      IF (MORSYM .AND. .NOT.INTFL2) GOTO 200
C
CBS   IF (INTFLG .AND. TDEF .AND. (.NOT.INTFL2)) THEN
CBS     defined in the master xref buffer as an intrinsic AND
CBS     is not present on the master INTRINSIC list, add it to the list
CBS     INTCNT = INTCNT + 1
CBS     CINTRN(INTCNT) = CSTRNG
CBS   END IF
C
      ERRCOD = 0
      RETURN
      END

C
C
C
      SUBROUTINE   CKEXTR (
     I                      CSTRNG,
     O                      EXTFLG, NEWEXT, ERRCOD)
C
C     + + + PURPOSE + + +
C     routine to determine if CSTRNG is the name of an EXTERNAL
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER       ERRCOD
      CHARACTER*(*) CSTRNG
      LOGICAL       EXTFLG, NEWEXT
C
C     + + + ARGUMENT DEFINITIONS + + +
C     CSTRNG - character string passed from calling routine
C              to be checked against master xref buffer
C     EXTFLG - LOGICAL flag which indicates if CSTRNG is the
C              name of an EXTERNAL routine
C     NEWEXT - flag to indicate that a match was not found
C              but that it was determined that CSTRNG is an
C              external routine which was added to master xref
C              buffer
C     ERRCOD - error code returned to calling program
C               0 - operation was successful
C              -1 - operation failed
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'cxref.inc'
      INCLUDE 'ctokeb.inc'
      INCLUDE 'ctokea.inc'
      INCLUDE 'ctokec.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER SYMLOC, STARTL
      LOGICAL GETOUT, MORSYM
C
C     + + + EXTERNALS + + +
      EXTERNAL CLTBUF, XTBUF, FNDSYM
C
C     + + + OUTPUT FORMATS + + +
 2000 FORMAT(/,'   Routine ',A8,' found on line ',I5,' of routine ',A,/,
     +         '   but not defined as EXTERNAL')
C
C
C     + + + END SPECIFICATIONS + + +
C
      ERRCOD = 0
      EXTFLG = .FALSE.
      NEWEXT = .FALSE.
      GETOUT = .FALSE.
C     if CSTRNG is the first token on the line it is not an EXTERNAL
      IF (TNUM .EQ. 1) GETOUT = .TRUE.
      IF (.NOT.GETOUT) THEN
        MORSYM = .TRUE.
        SYMLOC = 0
 100    CONTINUE
          STARTL = SYMLOC + 1
          CALL FNDSYM (CSTRNG, STARTL, SYMLOC, ERRCOD)
          IF (ERRCOD .EQ. 0) THEN
            IF (CLASS(SYMLOC) .EQ. 'X') THEN
C             found symbol in the main xref buffer
              EXTFLG = .TRUE.
            END IF
          ELSE
C           no more symbols
            MORSYM = .FALSE.
          END IF
        IF (MORSYM .AND. .NOT.EXTFLG) GOTO 100
C
        IF ((.NOT.EXTFLG) .AND. TKBUFF(TNUM-1) .EQ. 'CALL') THEN
C         CSTRNG was not defined in the master xref buffer as an
C         external but is preceeded by the reserved word 'CALL'
C         add it to the maxter xref buffer
          WRITE (*,2000) CSTRNG(1:8), PRLINE, MODULE(SYMNUM)
          EXTFLG = .TRUE.
          CALL CLTBUF
          TSYMNM = TOKEN(1:TOKLEN)
          TCLASS = 'X'
          TDEFIN = .TRUE.
          TLINEN = PRLINE
          SYMNUM = SYMNUM + 1
          CALL XTBUF
          NEWEXT = .TRUE.
        END IF
      END IF
      ERRCOD = 0
      RETURN
      END
C
C
C
      SUBROUTINE   CKUSE  (
     O                      USEFLG, ERRCOD)
C
C     + + + PURPOSE + + +
C     routine to determine if current token was used as an
C     argument to an INTRINSIC or EXTERNAL routine
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER       ERRCOD
      LOGICAL       USEFLG
C
C     + + + ARGUMENT DEFINITIONS + + +
C     USEFLG - LOGICAL flag which indicates if token was
C              used as an argument to an INTRINSIC or
C              EXTERNAL routine
C     ERRCOD - error code returned to calling program
C               0 - operation was successful
C              -1 - operation failed
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'ctokeb.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER  OLDNUM, PLEVEL, ERRFLG
      LOGICAL  TORF, QUOTES, RWDFLG, NEWEXT, GETOUT
C
C     + + + EXTERNALS + + +
      EXTERNAL  LOADBF, CKINTR, CKEXTR, RWORD, ERROUT, BUMPTK
C
C     + + + END SPECIFICATIONS + + +
C
      ERRCOD = 0
      PLEVEL = 0
      QUOTES = .FALSE.
      RWDFLG = .FALSE.
      OLDNUM = TNUM
      USEFLG = .FALSE.
      GETOUT = .FALSE.
      TNUM = OLDNUM
 100  CONTINUE
        TORF = .FALSE.
        IF (TNUM .GT. 1) THEN
C         fetch previous token
          CALL BUMPTK(-1,ERRFLG)
          IF (ERRFLG .EQ. 0) THEN
C           token fetched - process it
            IF (TTYPE .EQ. 'C') THEN
C             token is a character string
              CALL RWORD (TOKEN(1:TOKLEN), RWDFLG, ERRCOD)
              IF (RWDFLG) THEN
C               token is a reserved word, skip it
                RWDFLG = .FALSE.
              ELSE
C               see if token is an INTRINSIC
                CALL CKINTR (TOKEN(1:TOKLEN), TORF, ERRCOD)
                IF (ERRCOD .NE. 0) THEN
                  CALL ERROUT(' Error in call to CKINTR','CKUSE')
                  GETOUT = .TRUE.
                ELSE IF (.NOT.TORF) THEN
C                 see if token is an EXTERNAL
                  CALL CKEXTR (TOKEN(1:TOKLEN), TORF, NEWEXT, ERRCOD)
                  IF (ERRCOD .NE. 0) THEN
                    CALL ERROUT(' Error in call to CKEXTR','CKUSE')
                    GETOUT = .TRUE.
                  END IF
                END IF
              END IF
            ELSE IF (TTYPE .EQ. 'D') THEN
C             examine delimeter type tokens
              IF (TOKEN(1:TOKLEN) .EQ. '(') THEN
                IF (.NOT. QUOTES) PLEVEL = PLEVEL + 1
              ELSE IF (TOKEN(1:TOKLEN) .EQ. ')') THEN
                IF (.NOT. QUOTES) PLEVEL = PLEVEL - 1
              ELSE IF (TOKEN(1:TOKLEN) .EQ. 1H' .AND. QUOTES) THEN
                QUOTES = .FALSE.
              ELSE IF (TOKEN(1:TOKLEN) .EQ. 1H' .AND. .NOT.QUOTES) THEN
                QUOTES = .TRUE.
              END IF
            END IF
          ELSE
C           no more tokens
            GETOUT = .TRUE.
          END IF
        ELSE
C         no more tokens
          GETOUT = .TRUE.
        END IF
      IF (.NOT.GETOUT .AND. .NOT.TORF) GOTO 100
C
      IF (.NOT.GETOUT) THEN
C       found the name of an INTRINSIC or EXTERNAL routine
C       preceeding the location of the token being investigated
        IF (PLEVEL .GT. 0 .AND. .NOT. QUOTES) THEN
C         variable is within parins AND not inside quotes
C         variable is used as an argument to an INTRINSIC
C         or EXTERNAL routine
          USEFLG = .TRUE.
        END IF
      END IF
      TNUM = OLDNUM
      CALL LOADBF(ERRFLG)
      RETURN
      END
C
C
C
      SUBROUTINE   CKMOD  (
     I                      CSTRNG,
     O                      MODFLG, ERRCOD)
C
C     + + + PURPOSE + + +
C     routine to determine if the value of the variable CSTRNG
C     was modified in the current source code line
C
C     + + + DUMMY ARGUMENTS + + +
      CHARACTER*(*) CSTRNG
      LOGICAL       MODFLG
      INTEGER       ERRCOD
C
C     + + + ARGUMENT DEFINITIONS + + +
C     CSTRNG - character string passed from calling routine
C              to be checked against master xref buffer
C     MODFLG - flag which indicates if value of CSTRNG was modified
C     ERRCOD - error code returned to calling program
C               0 - operation was successful
C              -1 - operation failed
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'ctokea.inc'
      INCLUDE 'ctokeb.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER  OLDNUM, PLEVEL, EQPOS, EQPOSL, EQPOSR, ERRFLG
      LOGICAL  TORF, LOFEQ, QUOTES, EQFLAG, RWDFLG, NEWEXT,
     +         GETOUT, MORTOK
C
C     + + + EXTERNALS + + +
      EXTERNAL  LOADBF, CKINTR, CKEXTR, RWORD, ERROUT, BUMPTK
C
C     + + + END SPECIFICATIONS + + +
C
      ERRCOD = 0
      GETOUT = .FALSE.
      OLDNUM = TNUM
      PLEVEL = 0
      EQPOS  = 0
      EQPOSL = 0
      EQPOSR = ITEMS
      QUOTES = .FALSE.
      MODFLG = .FALSE.
      LOFEQ  = .TRUE.
      RWDFLG = .FALSE.
      EQFLAG = .FALSE.
      TNUM   = 0
 100  CONTINUE
        CALL BUMPTK(1,ERRFLG)
        IF (ERRFLG .EQ. 0) THEN
C         process token
          IF (TTYPE .EQ. 'D' .AND. TOKEN(1:TOKLEN) .EQ. '=') THEN
C           token is an equal sign, capture its position
            EQPOS = TNUM
            IF (EQPOSR .NE. ITEMS) THEN
C             this is other than the first equal sign found, use the
C             position of the previous equal sign as a left boundary and
C             use the value of the current equal sign as a right boundary
              EQPOSL = EQPOSR
              EQPOSR = EQPOS
            ELSE
C             this is the first equal sign found - leave EQPOSL equal
C             to 0 and set right boundary value equal to position of
C             the equal sign
              EQPOSR = EQPOS
            END IF
            IF (OLDNUM .GT. EQPOSR) THEN
C             CSTRNG is to the right of the equal sign
C             set tnum equal to the position of the equal sign
              TNUM = EQPOS
            ELSE IF (OLDNUM .GT. EQPOSR .OR. OLDNUM .LT. EQPOSL) THEN
C             CSTRNG is not between the equal signs
C             set tnum equal to the position of the equal sign
              TNUM = EQPOS
            ELSE
              EQFLAG = .TRUE.
            END IF
          END IF
        ELSE
C         requested token is out of range
          GETOUT = .TRUE.
        END IF
      IF (.NOT.GETOUT .AND. .NOT.EQFLAG) GOTO 100
C
      IF (.NOT.GETOUT) THEN
C       found an equal sign
        IF ((OLDNUM + 1) .EQ. EQPOSR) THEN
C         equal sign is to the immediate right of CSTRNG
          MODFLG = .TRUE.
          GETOUT = .TRUE.
        ELSE IF (.NOT.GETOUT) THEN
C         step backwards through tokens to see how CSTRNG was
C         used relative to the equal sign
          TORF   = .FALSE.
          TNUM   =  EQPOSR
          MORTOK = .TRUE.
 300      CONTINUE
            IF (TNUM .GT. (OLDNUM + 1)) THEN
C             there are more tokens to fetch
              CALL BUMPTK(-1,ERRFLG)
              IF (ERRFLG .EQ. 0) THEN
C               token fetched
                IF (TTYPE .EQ. 'C') THEN
C                 token is a character string
C                 is it a reserved word?
                  CALL RWORD (TOKEN, RWDFLG, ERRCOD)
                  IF (RWDFLG) THEN
C                 if token is a reserved word, CSTRNG was not modified
                    MODFLG = .FALSE.
                    GETOUT = .TRUE.
                  END IF
                  IF (.NOT.GETOUT) THEN
C                   is token an INTRINSIC ?
                    CALL CKINTR (CSTRNG, TORF, ERRCOD)
                    IF (ERRCOD .NE. 0) THEN
                      CALL ERROUT(' Error in call to CKINTR','CKUSE')
                      GETOUT = .TRUE.
                    ELSE IF (TORF) THEN
C                     CSTRNG was not modified - return
                      MODFLG = .FALSE.
                      GETOUT = .TRUE.
                    ELSE
C                     is token an EXTERNAL ?
                      CALL CKEXTR (CSTRNG, TORF, NEWEXT, ERRCOD)
                      IF (ERRCOD .NE. 0) THEN
                        CALL ERROUT(' Error in call to CKEXTR','CKUSE')
                        GETOUT = .TRUE.
                      ELSE IF (TORF) THEN
C                       token is an EXTERNAL, CSTRNG was not modified
                        MODFLG = .FALSE.
                        GETOUT = .TRUE.
                      END IF
                    END IF
                  END IF
                ELSE IF (TTYPE .EQ. 'D') THEN
C                 token is a delimeter
                  IF (TOKEN(1:TOKLEN) .EQ. '(') THEN
C                   token is an open parin
                    IF (.NOT. QUOTES) THEN
C                     open parin is not inside quotes
C                     bump parin counter
                      PLEVEL = PLEVEL + 1
                    END IF
                  ELSE IF (TOKEN(1:TOKLEN) .EQ. ')') THEN
C                   token is a close parin
                    IF (.NOT. QUOTES) THEN
C                     close parin is not inside quotes,
C                     decrement parin counter
                      PLEVEL = PLEVEL - 1
                    END IF
                  ELSE IF (TOKEN(1:TOKLEN) .EQ. 1H'
     +                     .AND. (.NOT.QUOTES)) THEN
C                   token is the first quote mark found, (begin quote)
                    QUOTES = .TRUE.
                  ELSE IF (TOKEN(1:TOKLEN) .EQ. 1H'
     +                     .AND. QUOTES) THEN
C                   token is the second quote mark found, (end quote)
                    QUOTES = .FALSE.
                  ELSE IF (TOKEN(1:TOKLEN) .EQ. 1H,) THEN
C                   token is a comma, CSTRNG not modified
                    GETOUT = .TRUE.
                  END IF
                END IF
              ELSE
C               requested token is out of range
                GETOUT = .TRUE.
                MORTOK = .FALSE.
              END IF
            ELSE
C             no more tokens to process
              MORTOK = .FALSE.
            END IF
          IF (.NOT.GETOUT .AND. MORTOK) GOTO 300
          IF (.NOT.GETOUT) THEN
            IF (PLEVEL .EQ. 0 .AND. (.NOT. QUOTES)) THEN
C             CSTRNG is to the left of the equal sign and there
C             are no single parins or quotes between CSTRNG and
C             equal sign, therefore CSTRNG is modified
              MODFLG = .TRUE.
              GETOUT = .TRUE.
            END IF
          END IF
        END IF
      END IF
      TNUM = OLDNUM
      CALL LOADBF(ERRFLG)
      RETURN
      END
C
C
C
      SUBROUTINE   CKRDWR  (
     O                      MODFLG, ERRCOD)
C
C     + + + PURPOSE + + +
C     routine to determine if the value of the current token
C     was used in a READ or WRITE statement and to determine
C     if it was modified
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER       ERRCOD
      LOGICAL       MODFLG
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MODFLG - flag which indicates if token was modified
C     ERRCOD - error code returned to calling program
C               0 - operation was successful
C              -1 - operation failed
C              -2 - token is not used in a READ/WRITE statement
C              -3 - token was used as an argument in the READ/WRITE
C                   statement control list (e.g. file unit number)
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'ctokea.inc'
      INCLUDE 'ctokeb.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER  OLDNUM, PLEVEL, ERRFLG, RDWRTY
      LOGICAL  QUOTES, GETOUT, RDWRST, MORTOK
C
C     + + + EXTERNALS + + +
      EXTERNAL  LOADBF, BUMPTK
C
C     + + + END SPECIFICATIONS + + +
C
      ERRCOD = 0
      GETOUT = .FALSE.
      PLEVEL = 0
      QUOTES = .FALSE.
      MODFLG = .FALSE.
      OLDNUM = TNUM
C
C     determine position of the READ token
      RDWRST = .FALSE.
      RDWRTY = 0
      TNUM   = 0
 100  CONTINUE
        MORTOK = .TRUE.
        CALL BUMPTK(1,ERRFLG)
        IF (ERRFLG .EQ. 0) THEN
C         process token
          IF (TOKEN(1:TOKLEN) .EQ. 'READ') RDWRTY = 1
          IF (TOKEN(1:TOKLEN) .EQ. 'WRITE') RDWRTY = 2
          IF (RDWRTY .GT. 0) THEN
            IF (TNUM .GT. 1) THEN
              IF (TKTYPE(TNUM-1) .EQ. 'N' .OR.
     +             (TKTYPE(TNUM-1) .EQ. 'D'.AND.
     +              TKBUFF(TNUM-1) .EQ. ')')) THEN
C               this is a READ/WRITE statment
                RDWRST = .TRUE.
              END IF
            ELSE
C             the word READ or WRITE was first token on line
              RDWRST = .TRUE.
            END IF
          END IF
        ELSE
C         no more tokens
          MORTOK = .FALSE.
        END IF
      IF (MORTOK .AND. .NOT.RDWRST) GOTO 100
C
      IF (.NOT.RDWRST .OR. OLDNUM .LE. TNUM) THEN
C       this is not a READ/WRITE statement or variable being evaluated
C       is not part of the READ/WRITE statement control list
        ERRCOD = -2
        GETOUT = .TRUE.
      ELSE
        CALL BUMPTK(1,ERRFLG)
        IF (ERRFLG .EQ. 0) THEN
C         process token
          IF (TTYPE .EQ. 'D') THEN
C           a delimeter follows the word 'READ' or 'WRITE'
            IF (TOKEN(1:TOKLEN) .EQ. '(') THEN
C             the delimeter is an open parin
C             increment the parin level
              PLEVEL = 1
            END IF
          END IF
        END IF
      END IF
C
      IF (.NOT.GETOUT .AND. PLEVEL .EQ. 1 ) THEN
C       found the word READ or WRITE followed by an open parin
C       evaluate more tokens
        MORTOK = .TRUE.
 200    CONTINUE
          CALL BUMPTK(1,ERRFLG)
          IF (ERRFLG .EQ. 0) THEN
C           process token
            IF (TNUM .EQ. OLDNUM) THEN
              IF (PLEVEL .NE. 0) THEN
C               token being evaluated is part of READ/WRITE control list
                ERRCOD = -3
                MODFLG = .TRUE.
                GETOUT = .TRUE.
              END IF
            ELSE IF (TTYPE .EQ. 'D') THEN
C             evaluate token
C             token is a delimeter
              IF (TOKEN(1:TOKLEN) .EQ. '(') THEN
C               found open parin, increment parin counter
                IF (.NOT. QUOTES) PLEVEL = PLEVEL + 1
              ELSE IF (TOKEN(1:TOKLEN) .EQ. ')') THEN
C               found close parin, decrement parin counter
                IF (.NOT. QUOTES) PLEVEL = PLEVEL - 1
              ELSE IF (TOKEN(1:TOKLEN) .EQ. 1H' .AND. QUOTES) THEN
C               found quotation mark, toggle quote flag
                QUOTES = .FALSE.
              ELSE IF (TOKEN(1:TOKLEN) .EQ. 1H'
     +                 .AND. (.NOT.QUOTES)) THEN
C               found quotation mark, toggle quote flag
                QUOTES = .TRUE.
              END IF
            END IF
            IF (.NOT.GETOUT .AND.
     +          PLEVEL .EQ. 0 .AND. (.NOT. QUOTES) ) THEN
              IF (OLDNUM .GE. TNUM) THEN
C               token is part of READ/WRITE I/O list
                IF (RDWRTY .EQ. 1) MODFLG = .TRUE.
                MORTOK = .FALSE.
                GETOUT = .TRUE.
              END IF
            END IF
          ELSE
C           no more tokens
            GETOUT = .TRUE.
          END IF
        IF (.NOT.GETOUT) GOTO 200
      END IF
      TNUM = OLDNUM
      CALL LOADBF(ERRFLG)
      RETURN
      END
