C
C
C
      SUBROUTINE   OPTSET
C
C     + + + PURPOSE + + +
C     Sets the options for sysdoc processing.  First sets all parameters
C     to the initial defaults.  Then checks for a local user file named
C     OPTION.SD for any changes to the parameters.
C
C     + + + COMMONS + + +
      INCLUDE 'cstopt.inc'
      INCLUDE 'cfiles.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      OPTND(16), OPTNMN(16), OPTNMX(16), MISS,
     $             LENOPT, LEN, LEN6, LEN10, FUNIT, IOS, MATCH, KNT,
     $             CONT, MORE, OPTPFX
      CHARACTER*6  OPTNC(16), LOOK
      CHARACTER*8  PREFIX
      CHARACTER*64 VERSN
      CHARACTER*80 RECORD
C
C     + + + FUNCTIONS + + +
      INTEGER   CRINTE, LENSTR
C
C     + + + EXTERNALS + + +
      EXTERNAL   COPYI, ZIPI, QUPCAS, CRINTE, LENSTR, ZTRIM
C
C     + + + DATA INITIALIZATIONS + + +
C                     pgopt     lpage     margl     margr     martp
C                     pcntm     pcnti     pcntc     pcntu     debug
C                     clean     optref    optnam    optmer    optind
C                     dintln
      DATA  OPTNC  / 'PGFORM', 'PGLINE', 'MARGLF', 'MARGRT', 'MARGTP',
     $               'PGMAIN', 'PGINTR', 'PGCOMN', 'PGUNKN', 'DEBUG ',
     $               'CLEAN ', 'STXREF', 'STARGF', 'MERGE ', 'INDEX ',
     $               'INTLEN'  /
      DATA  OPTND  /     1,       80,       10,       18,        2,
     $                   1,        1,        1,        1,        0,
     $                   1,        1,        1,        1,        0,
     $                   4     /
      DATA  OPTNMN /     0,       20,        1,        1,        1,
     $                   1,        1,        1,        1,        0,
     $                   0,        0,        0,        0,        0,
     $                   1     /
      DATA  OPTNMX /     1,      120,       20,       20,      110,
     $                9999,     9999,     9999,     9999,        4,
     $                   1,        1,        1,        1,        1,
     $                   6     /
      DATA  LEN6, LEN10, LENOPT, MISS, FUNIT
     $     /   6,    10,     16,  -99,    50 /
C
C     + + + INPUT FORMATS + + +
 1010 FORMAT ( A80 )
 1015 FORMAT ( A8 )
C
C     + + + OUTPUT FORMATS
 2000 FORMAT ( 1X, 'Using default options.' )
 2001 FORMAT ( 1X, 'Using options from file ', A )
 2010 FORMAT ( 1X, 'Unable to read parameter value in option file:',
     $       /,1X, 5X, 80A1 )
 2011 FORMAT ( 1X, A6, ' = ', I6 ' is invalid, the valid range is ',
     $             2I6 )
 2012 FORMAT ( 1X, 'Unrecognized parameter in option file:',
     $       /,1X, 5X, A80 )
 2300 FORMAT ( ' SYSDOC output can be found in the following files:'
     $       /,'       ', A14, ' List of input source code',
     $       /,'       ', A14, ' Report on routines',
     $       /,'       ', A14, ' Report on intrinsics',
     $       /,'       ', A14, ' Report on commons',
     $       /,'       ', A14, ' Report on unknowns',
     $       /,'       ', A14, ' alphabetical index',
     $       /,'       ', A14, ' sorted index' )
C
C     + + + END SPECIFICATIONS + + +
C     version info for unix what,
C     file contining list of valid intrinsics, set file names to defaults
      INCLUDE 'fsysdc.inc'
      OPTPFX = 0
C
C     check for user option file
      OPEN ( UNIT = FUNIT,
     $       FILE = COPT,
     $     STATUS = 'OLD',
     $     IOSTAT = IOS )
      IF (IOS .NE. 0) THEN
C       no option file or problem opening it, use defaults
        WRITE (*,2000)
        CALL COPYI ( LENOPT, OPTND, OPTNV )
        KEYFLG = '+ + +'
        KEYPUR = 'PURPOSE'
        KEYARG = 'ARGUMENT'
      ELSE
C       file opened, update options
        WRITE (*,2001) COPT
        CALL ZIPI ( LENOPT, MISS, OPTNV )
        CONT = 1
 100    CONTINUE
C         read next record from option file
          READ (FUNIT,1010,END=180) RECORD
C           successful read, check for match
            LOOK = RECORD(1:6)
            CALL QUPCAS ( LEN6, LOOK )
            IF (LOOK(1:1) .EQ. '*'  .OR.  LOOK(1:1) .EQ. '#') THEN
C             comment, ignore this record
            ELSE IF (LOOK(1:3) .EQ. 'KEY') THEN
C             key word identifiers
              write (*,*) ' key word identifiers not supported.'
            ELSE IF (LOOK(1:6) .EQ. 'PREFIX') THEN
C             modified file name prefix
              READ (RECORD(8:15),1015) PREFIX
              OPTPFX = 1
            ELSE
C             check for option parameter
              KNT = 0
              MORE = 1
 110          CONTINUE
                KNT = KNT + 1
                IF (LOOK .EQ. OPTNC(KNT)) THEN
C                 matched the option
                  MORE = 0
                  LEN = LENSTR ( LEN10, RECORD(7:16) )
                  IF (LEN .GT. 0) THEN
C                   found a value in the data field, save it
                    OPTNV(KNT) = CRINTE ( MISS, LEN, RECORD(7:6+LEN) )
                  END IF
                  IF (OPTNV(KNT) .EQ. MISS) THEN
C                   problem with parameter value
                    WRITE (*,2010) RECORD
                  ELSE IF (OPTNV(KNT) .LT. OPTNMN(KNT)  .OR.
     $                     OPTNV(KNT) .GT. OPTNMX(KNT)) THEN
C                   parameter outside valid range
                    WRITE (*,2011) LOOK, OPTNV(KNT),
     $                             OPTNMN(KNT), OPTNMX(KNT)
                    OPTNV(KNT) = MISS
                  END IF
                END IF
              IF (MORE .EQ. 1  .AND.  KNT .LT. LENOPT) GO TO 110
              IF (MORE .EQ. 1) THEN
C               record not recognized as a comment, key word, or parameter
                WRITE (*,2012) RECORD
              END IF
C             done looking for a match for this record
            END IF
            GO TO 190
 180      CONTINUE
C           end of input file
            CONT = 0
 190      CONTINUE
C         go back for another record if available
        IF (CONT .EQ. 1) GO TO 100
C       finished reading file, set undefined or invalid parameters
        DO 290 KNT = 1, LENOPT
          IF (OPTNV(KNT) .EQ. MISS) THEN
C           no value entered for this option
            OPTNV(KNT) = OPTND(KNT)
          END IF
 290    CONTINUE
        CLOSE ( UNIT = FUNIT )
        IF (OPTPFX .EQ. 1) THEN
C         set prefix for sysdoc standard input and output files
          CINP  = PREFIX//'.inp'
          COUT  = PREFIX//'.out'
          COUTI = PREFIX//'.int'
          COUTC = PREFIX//'.com'
          COUTU = PREFIX//'.unk'
          CIND  = PREFIX//'.ina'
          CSIND = PREFIX//'.ins'
          CALL ZTRIM ( CINP )
          CALL ZTRIM ( COUT )
          CALL ZTRIM ( COUTI )
          CALL ZTRIM ( COUTC )
          CALL ZTRIM ( COUTU )
          CALL ZTRIM ( CIND )
          CALL ZTRIM ( CSIND )
        END IF
      END IF
C     where will the output go:
      WRITE (*,2300) CINP, COUT, COUTI, COUTC, COUTU, CIND, CSIND
C
      RETURN
      END
C
C
C
      SUBROUTINE   OPTOPT
     O                   ( OPTREF, OPTNAM, OPTMER, OPTIND,
     O                     DINTLN, DEBUG,  CLEAN )
C
C     + + + PURPOSE + + +
C     returns opt parameters to calling routine
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   OPTREF, OPTNAM, OPTMER, OPTIND, DINTLN, DEBUG,  CLEAN
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'cstopt.inc'
C
C     + + + END SPECIFICATIONS + + +
C
C     set the defaults
      OPTREF = OPTNV(12)
      OPTNAM = OPTNV(13)
      OPTMER = OPTNV(14)
      OPTIND = OPTNV(15)
      DINTLN = OPTNV(16)
      DEBUG  = OPTNV(10)
      CLEAN  = OPTNV(11)
C
      RETURN
      END
C
C
C
      SUBROUTINE   OPTPRM
     O                   ( LPAGE, MARGL, MARGR, MARTP, 
     O                     PCNTM, PCNTI, PCNTC, PCNTU, PGOPT )
C
C     + + + PURPOSE + + +
C     returns parm parameters to calling routine
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   LPAGE, MARGL, MARGR, MARTP,
     $          PCNTM, PCNTI, PCNTC, PCNTU, PGOPT
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'cstopt.inc'
C
C     + + + END SPECIFICATIONS + + +
C
C     set the paramater values 
      LPAGE = OPTNV(2)
      MARGL = OPTNV(3)
      MARGR = OPTNV(4)
      MARTP = OPTNV(5)
      PCNTM = OPTNV(6)
      PCNTI = OPTNV(7)
      PCNTC = OPTNV(8)
      PCNTU = OPTNV(9)
      PGOPT = OPTNV(1)
C
      RETURN
      END
C
C
C 
      SUBROUTINE   OPTKEY
C
C     + + + PURPOSE + + +
C     returns key identifiers.
C
C     + + + END SPECIFICATIONS + + +
C
C
      RETURN
      END
