C
C
C
      SUBROUTINE   CTPAGE
     I                    (FTYP,BUFMRL,BUFMRR,LPAGE,NLINS,CNAM,MARTP,
     I                     PGOPT,MARGL,MARGR,
     M                     BUFMRG,LCNT)
C
C     + + + PURPOSE + + +
C     This routine counts pages and lines for documentation output,
C     and starts a new page when line count would exceed LPAGE.  It
C     also numbers the pages.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER       FTYP,LPAGE,LCNT,NLINS,MARTP,PGOPT,MARGL,MARGR
      CHARACTER*8   CNAM
      CHARACTER*20  BUFMRL,BUFMRR,BUFMRG
C
C     + + + ARGUMENT DEFINITIONS + + +
C     FTYP   - type of file to write output on
C     BUFMRL - left margin text
C     BUFMRR - right margin text
C     LPAGE  - number of lines per page
C     NLINS  - number of lines in next write statement
C     CNAM   - current name of routine being documented
C     MARTP  - margin at top of page
C     PGOPT  - page format options
C              0 = no page formatting
C              1 = page ejects and page number
C     MARGL  - left margin
C     MARGR  - right margin
C     BUFMRG - current page margin text
C     LCNT   - current line count
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'cfunit.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   TCNT, I
C
C     + + + INTRINSICS + + +
      INTRINSIC ABS,MOD
C
C     + + + EXTERNALS + + +
      EXTERNAL  PAGTOP
C
C     + + + OUTPUT FORMATS + + +
 2000 FORMAT (/A,32X,'-',I2,' -')
 2001 FORMAT (/A,32X,'-',I3,' -')
 2002 FORMAT (/A,31X,'-',I4,' -')
 2003 FORMAT (/A,31X,'-',I5,' -')
 2010 FORMAT (//A,A8,50X,A8,//)
 2020 FORMAT (' ')
C
C     + + + END SPECIFICATIONS + + +
C
      IF (PGOPT .EQ. 0) GOTO 999
      TCNT = NLINS + LCNT
      IF (TCNT .LE. LPAGE-2) THEN
C       enough room on this page
        LCNT = TCNT
      ELSE
C       not enough room, start new page
        IF (LCNT .LE. LPAGE) THEN
          DO 20 I = LCNT,LPAGE
C           add blank line
            WRITE(FOUT(FTYP),2020)
 20       CONTINUE
        END IF
        IF (PCNT(FTYP) .LT. 10) THEN
          WRITE (FOUT(FTYP),2000) BUFMRG(1:MARGL), PCNT(FTYP)
        ELSE IF (PCNT(FTYP) .LT. 100) THEN
          WRITE (FOUT(FTYP),2001) BUFMRG(1:MARGL), PCNT(FTYP)
        ELSE IF (PCNT(FTYP) .LT. 1000) THEN
          WRITE (FOUT(FTYP),2002) BUFMRG(1:MARGL), PCNT(FTYP)
        ELSE
          WRITE (FOUT(FTYP),2003) BUFMRG(1:MARGL), PCNT(FTYP)
        END IF
        PCNT(FTYP) = PCNT(FTYP) + 1
        IF (MOD(PCNT(FTYP),2).EQ.0) THEN
C         even page number
          BUFMRG= BUFMRR
        ELSE
C         odd page number
          BUFMRG= BUFMRL
        END IF
        LCNT = 0
        CALL PAGTOP (FOUT(FTYP), MARTP, PGOPT, LCNT)
        IF (CNAM .NE. 'ZZZZZZZZ')
     +      WRITE (FOUT(FTYP),2010) BUFMRG(1:MARGL), CNAM, CNAM
        LCNT= LCNT+ NLINS+ 5
      END IF
C
 999  CONTINUE
      RETURN
      END
C
C
C
      SUBROUTINE   NEWROU
     I                    (OFTYP,CFTYP,BUFMRL,BUFMRR,LPAGE,NLINS,
     I                     CNAM,CTYP,MARTP,PGOPT,MARGL,MARGR,
     M                     BUFMRG,LCNT,
     M                     MXROUT,INDCNT,INDPAG,INDNAM,INDTYP)
C
C     + + + PURPOSE + + +
C     routine to do everything to start a new routines documentation
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER       OFTYP,CFTYP,LPAGE,NLINS,MARTP,PGOPT,LCNT,
     &              MXROUT,INDCNT,INDPAG(MXROUT),MARGL,MARGR
      CHARACTER*1   INDTYP(MXROUT),CTYP
      CHARACTER*8   CNAM,INDNAM(MXROUT)
      CHARACTER*20  BUFMRL,BUFMRR,BUFMRG
C
C     + + + ARGUMENT DEFINITIONS + + +
C     OFTYP  - old type of file
C     CFTYP  - current type of file
C     BUFMRL - left margin text
C     BUFMRR - right margin text
C     LPAGE  - number of lines per page
C     NLINS  - number of lines in next write statement
C     CNAM   - current name of routine being documented
C     CTYP   - current type of routine being documented
C     MARTP  - margin at top of page
C     PGOPT  - page format options
C              0 = no page formatting
C              1 = page ejects and page number
C     MARGL  - left margin
C     MARGR  - right margin
C     BUFMRG - current page margin text
C     LCNT   - current line count
C     MXROUT - maximum number of routines
C     INDCNT - count of routines processed
C     INDPAG - page number where routine doc starts
C     INDNAM - name of routine for index
C     INDTYP - type of routine for index
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'cfunit.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER    I
C
C     + + + INTRINSICS + + +
      INTRINSIC  MOD
C
C     + + + EXTERNALS + + +
      EXTERNAL   PAGTOP
C
C     + + + OUTPUT FORMATS + + +
 2000 FORMAT (/A,32X,'-',I2,' -')
 2001 FORMAT (/A,32X,'-',I3,' -')
 2002 FORMAT (/A,31X,'-',I4,' -')
 2003 FORMAT (/A,31X,'-',I5,' -')
 2020 FORMAT (' ')
C
C     + + + END SPECIFICATIONS + + +
C
      IF (PGOPT .EQ. 0) GOTO 999
      IF (OFTYP.GT.0) THEN
        IF (PCNT(OFTYP) .GT. 0) THEN
C         put page number at bottom of current page
          IF (LCNT .LE. LPAGE .AND. PGOPT .NE. 0) THEN
            DO 10 I = LCNT,LPAGE
C             add blank line
              WRITE(FOUT(OFTYP),2020)
 10         CONTINUE
          END IF
          IF (PGOPT .NE. 0) THEN
            IF (PCNT(OFTYP) .LT. 10) THEN
              WRITE (FOUT(OFTYP),2000) BUFMRG(1:MARGL), PCNT(OFTYP)
            ELSE IF (PCNT(OFTYP) .LT. 100) THEN
              WRITE (FOUT(OFTYP),2001) BUFMRG(1:MARGL), PCNT(OFTYP)
            ELSE IF (PCNT(OFTYP) .LT. 1000) THEN
              WRITE (FOUT(OFTYP),2002) BUFMRG(1:MARGL), PCNT(OFTYP)
            ELSE
              WRITE (FOUT(OFTYP),2003) BUFMRG(1:MARGL), PCNT(OFTYP)
            END IF
          END IF
        END IF
        LCNT = 0
        PCNT(OFTYP) = PCNT(OFTYP) + 1
      END IF
C
      IF (MOD(PCNT(CFTYP),2).EQ.0) THEN
C       even page number
        BUFMRG= BUFMRR
      ELSE
C       odd page number
        BUFMRG= BUFMRL
      END IF
C
C     start new page
      CALL PAGTOP (FOUT(CFTYP),MARTP,PGOPT, LCNT)
      LCNT  = LCNT+ NLINS
      INDCNT= INDCNT+ 1
      INDPAG(INDCNT)= PCNT(CFTYP)
      INDNAM(INDCNT)= CNAM
      INDTYP(INDCNT)= CTYP
C
 999  CONTINUE
      RETURN
      END
C
C
C
      SUBROUTINE   PAGTOP
     I                    (FOUT,MARTP,PGOPT,
     M                     LCNT)
C
C     + + + PURPOSE + + +
C     This routine puts 1 for page control and MARTP blank lines.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   FOUT, MARTP, PGOPT, LCNT
C
C     + + + ARGUMENT DEFINITIONS + + +
C     FOUT   - unit number of file to write output on
C     MARTP  - number of blank lines at top of page
C     PGOPT  - page format options
C              0 = no page formatting
C              1 = page ejects and page number
C     LCNT   - count on number of lines on a page
C
C     + + + LOCAL VARIABLES + + +
      INTEGER   I
C
C     + + + OUTPUT FORMATS + + +
 2000 FORMAT ('1')
 2001 FORMAT (' ')
C
C     + + + END SPECIFICATIONS + + +
C
      IF (PGOPT .EQ. 1) THEN
C       output fortran page eject
        WRITE(FOUT,2000)
      ELSE
C       no formatting has been selected
        WRITE(FOUT,2001)
      END IF
C
      DO 10 I = 1,MARTP-1
        WRITE(FOUT,2001)
 10   CONTINUE
      LCNT = LCNT + MARTP
      RETURN
      END
