C
C
C
      SUBROUTINE   FNDEXE
     O                   (DONFLG, NXTFLG, ERRCOD)
C
C     + + + PURPOSE + + +
C     routine to find and capture argument usage, common variable
C     usage, external routine usage, and intrinsic usage in
C     source code
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER       ERRCOD
      LOGICAL       NXTFLG, DONFLG
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DONFLG - flag to tell calling routine that this routine
C              has located the end of the specification statements
C              in the source code file
C     NXTFLG - flag to tell calling routine that the token
C              buffer has been successfully processed and that
C              the next line can be fetched and processed.
C     ERRCOD - error code returned to calling program
C               0 - operation was successful
C              -1 - operation failed
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'cxref.inc'
      INCLUDE 'ctokea.inc'
      INCLUDE 'ctokeb.inc'
      INCLUDE 'ctokec.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      SYMLOC, STARTL, QLEVEL, ERRFLG
      CHARACTER*80 TEMPNM
      LOGICAL      TORF, NEWEXT, GETOUT, NEXT, MORSYM
C
C     + + + INTRINSICS + + +
      INTRINSIC MOD
C
C     + + + EXTERNALS + + +
      EXTERNAL BUMPTK, RWORD,  ZIP,    CKARGS, FNDSYM, ERROUT,
     +         CKCOMV, CKINTR, CKEXTR, CLTBUF, XTBUF, CKMOD, CKUSE,
     +         CKRDWR, FNDLNO
C
C     + + + END SPECIFICATIONS + + +
C
      NXTFLG = .FALSE.
      DONFLG = .FALSE.
      NEWEXT = .FALSE.
      QLEVEL = 0
      ERRCOD = 0
      TNUM   = 0
C     clear token buffer
      CALL CLTBUF
C
C     loop to increment token buffer counter and load temporary
C     token buffer
 100  CONTINUE
        GETOUT = .FALSE.
        NEXT = .FALSE.
        TORF = .FALSE.
        CALL BUMPTK(1,ERRFLG)
        IF (ERRFLG .EQ. 0) THEN
C         process token
          IF (TEND .LE. 5 .AND. TOKLEN .LE. 5) THEN
C           token is a statement label, call routine to capture it
            CALL FNDLNO (NXTFLG, ERRCOD)
            IF (ERRCOD .NE. 0) THEN
              CALL ERROUT (' Error in call to FNDLNO','MAKXRF')
              GETOUT = .TRUE.
            END IF
            IF (NXTFLG) THEN
              GETOUT = .TRUE.
            ELSE
              NEXT = .TRUE.
            END IF
          END IF
C
          IF (.NOT.NEXT .AND. .NOT.GETOUT) THEN
            IF (TTYPE .EQ. 'D') THEN
C             token is a delimiter
              IF (TOKEN(1:TOKLEN) .EQ. 1H') THEN
C               token is a single quote, make sure it is a delimeter
                IF (TKBUFF(TNUM-1) .EQ. 1H' .AND.
     +              TKBUFF(TNUM+1) .EQ. 1H') THEN
C                 token is a single quote enclosed by single quotes
C                 in other words, it is a literal
                  NEXT = .TRUE.
                ELSE
C                 single quote is a delimeter, toggle quote level switch
C                 switch is 1 for an open quote and 0 for a close quote
                  QLEVEL = MOD (QLEVEL + 1, 2)
                END IF
              END IF
              NEXT = .TRUE.
            ELSE IF (TTYPE .EQ. 'C' .AND. QLEVEL .EQ. 0) THEN
C             token is a char string and is not enclosed in quotes
              IF (ITEMS .EQ. 1 .AND. TOKEN(1:TOKLEN) .EQ. 'END') THEN
C               there is only 1 token on the line and it is the
C               end of the routine (i.e. END)
                DONFLG = .TRUE.
                NXTFLG = .TRUE.
                GETOUT = .TRUE.
              ELSE
                CALL ZIP (' ',TEMPNM)
                TEMPNM = TOKEN(1:TOKLEN)
                CALL RWORD (TEMPNM, TORF, ERRCOD)
C
                IF (TORF) THEN
C                 a reserved word was found
                  IF (TOKEN(1:TOKLEN) .EQ. 'FORMAT' .AND.
     +                TNUM .EQ. 2 .AND. TKTYPE(1) .EQ. 'N') THEN
C                   token is FORMAT and this is the second token on
C                   the line where the first token was a statement
C                   label, therefore it is a FORMAT statement
                    GETOUT = .TRUE.
                    NXTFLG = .TRUE.
                  ELSE IF (TOKEN(1:TOKLEN) .EQ. 'CONTINUE' .AND.
     +                TNUM .EQ. 2 .AND. TKTYPE(1) .EQ. 'N') THEN
C                   token is CONTINUE and this is the second token on
C                   the line where the first token was a statement
C                   label, therefore it is a CONTINUE statement
                    GETOUT = .TRUE.
                    NXTFLG = .TRUE.
                  ELSE
C                   get next token
                    NEXT = .TRUE.
                  END IF
                END IF
C
                IF (.NOT.NEXT .AND. .NOT.GETOUT) THEN
C                 token is not a reserved word - is it an argument
                  CALL CKARGS (TEMPNM, TORF, ERRCOD)
                  IF (TORF) THEN
C                   token is an argument
                    CALL CKRDWR(TORF, ERRCOD)
                    IF (TORF .AND. ERRCOD .EQ. 0) THEN
C                     argument was modified in a READ/WRITE statement
                      CALL CLTBUF
                      TSYMNM = TOKEN(1:TOKLEN)
                      TCLASS = 'A'
                      TDEFIN = .FALSE.
                      TLINEN = PRLINE
                      TLNUSE = 'M'
                      SYMNUM = SYMNUM + 1
                      CALL XTBUF
                      NEXT = .TRUE.
                    ELSE IF (TORF .AND. ERRCOD .EQ. -3) THEN
C                     argument was used in the READ statement
C                     control list (argument used as an argument)
                      CALL CLTBUF
                      TSYMNM = TOKEN(1:TOKLEN)
                      TCLASS = 'A'
                      TDEFIN = .FALSE.
                      TLINEN = PRLINE
                      TLNUSE = 'A'
                      SYMNUM = SYMNUM + 1
                      CALL XTBUF
                      ERRCOD = 0
                      NEXT = .TRUE.
                    END IF
C
                    IF (.NOT.NEXT .AND. .NOT.GETOUT) THEN
                      IF (ERRCOD .EQ. -2) THEN
C                       argument was not used in a READ or WRITE
C                       statement
                        CALL CKMOD (TEMPNM, TORF, ERRCOD)
                        IF (TORF) THEN
C                         argument modified by an assignment statement
                          CALL CLTBUF
                          TSYMNM = TOKEN(1:TOKLEN)
                          TCLASS = 'A'
                          TDEFIN = .FALSE.
                          TLINEN = PRLINE
                          TLNUSE = 'M'
                          SYMNUM = SYMNUM + 1
                          CALL XTBUF
                          NEXT = .TRUE.
                        ELSE
C                         not used in an assignment statement
                          CALL CKUSE (TORF, ERRCOD)
                          IF (TORF) THEN
C                           argument was used as an argument to an
C                           intrinsic or in a call to an external
                            CALL CLTBUF
                            TSYMNM = TOKEN(1:TOKLEN)
                            TCLASS = 'A'
                            TDEFIN = .FALSE.
                            TLINEN = PRLINE
                            TLNUSE = 'A'
                            SYMNUM = SYMNUM + 1
                            CALL XTBUF
                            NEXT = .TRUE.
                          END IF
                        END IF
                      END IF
                    END IF
                  END IF
                END IF
C
                IF (.NOT.NEXT .AND. .NOT.GETOUT) THEN
C                 token is not an argument - is it a COMMON variable
                  CALL CKCOMV (TEMPNM, TORF, ERRCOD)
                  IF (TORF) THEN
C                   token is a COMMON variable
C                   check to see if this variable was modified in
C                   a READ/WRITE statement
                    CALL CKRDWR(TORF, ERRCOD)
                    IF (TORF .AND. ERRCOD .EQ. 0) THEN
C                     variable was modified in a READ/WRITE statement
                      CALL CLTBUF
                      TSYMNM = TOKEN(1:TOKLEN)
                      TCLASS = ' '
                      TDEFIN = .FALSE.
                      TLINEN = PRLINE
                      TLNUSE = 'M'
                      SYMNUM = SYMNUM + 1
                      CALL XTBUF
                      NEXT = .TRUE.
                    ELSE IF (TORF .AND. ERRCOD .EQ. -3) THEN
C                     variable was used in the READ statement
C                     control list
                      CALL CLTBUF
                      TSYMNM = TOKEN(1:TOKLEN)
                      TCLASS = ' '
                      TDEFIN = .FALSE.
                      TLINEN = PRLINE
                      TLNUSE = ' '
                      SYMNUM = SYMNUM + 1
                      CALL XTBUF
                      ERRCOD = 0
                      NEXT = .TRUE.
                    END IF
C
                    IF (.NOT.NEXT .AND. .NOT.GETOUT) THEN
                      IF (ERRCOD .EQ. -2) THEN
C                       variable was not used in a READ or WRITE
C                       statement, was it modified by an assignment
C                       statement?
                        CALL CKMOD (TEMPNM, TORF, ERRCOD)
                        IF (TORF) THEN
                          CALL CLTBUF
                          TSYMNM = TOKEN(1:TOKLEN)
                          TCLASS = ' '
                          TDEFIN = .FALSE.
                          TLINEN = PRLINE
                          TLNUSE = 'M'
                          SYMNUM = SYMNUM + 1
                          CALL XTBUF
                          NEXT = .TRUE.
                        END IF
                      END IF
C
C                     was variable used as an argument to an intrinsic
C                     or an external
                      CALL CKUSE (TORF, ERRCOD)
                      IF (TORF) THEN
                        CALL CLTBUF
                        TSYMNM = TOKEN(1:TOKLEN)
                        TCLASS = ' '
                        TDEFIN = .FALSE.
                        TLINEN = PRLINE
                        TLNUSE = 'A'
                        SYMNUM = SYMNUM + 1
                        CALL XTBUF
                        NEXT = .TRUE.
                      ELSE
                        CALL CLTBUF
                        TSYMNM = TOKEN(1:TOKLEN)
                        TCLASS = ' '
                        TDEFIN = .FALSE.
                        TLINEN = PRLINE
                        TLNUSE = ' '
                        SYMNUM = SYMNUM + 1
                        CALL XTBUF
                        NEXT = .TRUE.
                      END IF
                    END IF
                  END IF
                END IF
C
                IF (.NOT.NEXT .AND. .NOT.GETOUT) THEN
C                 token is not a COMMON variable - is it an INTRINSIC?
                  CALL CKINTR (TEMPNM, TORF, ERRCOD)
                  IF (TORF) THEN
C                   token is an INTRINSIC - process it
C                   loop through the master INTRINSIC an look for
C                   for each occurance of the INTRINSIC and capture
C                   the INTRINSIC type if it is defined
                    SYMLOC = 0
 300                CONTINUE
                      STARTL = SYMLOC + 1
                      CALL FNDSYM (TEMPNM, STARTL, SYMLOC, ERRCOD)
C                     if type is defined, capture it
                      IF (ERRCOD .EQ. 0) THEN
                        IF (ATRIB1(SYMLOC) .NE. ' ')
     +                      TATRB1 = ATRIB1(SYMLOC)
                        IF (ATRIB2(SYMLOC) .NE. 0)
     +                      TATRB2 = ATRIB2(SYMLOC)
                        MORSYM = .TRUE.
                      ELSE
C                       log the use of the intrinsic
                        ERRCOD = 0
                        TSYMNM = TOKEN(1:TOKLEN)
                        TCLASS = 'I'
                        TLINEN = PRLINE
                        SYMNUM = SYMNUM + 1
                        CALL XTBUF
                        NEXT = .TRUE.
                        MORSYM = .FALSE.
                      END IF
                    IF (MORSYM) GOTO 300
                  END IF
                END IF
C
                IF (.NOT.NEXT .AND. .NOT.GETOUT) THEN
C                 token is not an INTRINSIC - is it an EXTERNAL
                  CALL CKEXTR (TEMPNM, TORF, NEWEXT, ERRCOD)
                  IF (TORF) THEN
C                   token is an EXTERNAL - process it
                    IF (.NOT.NEWEXT) THEN
C                     external was previously defined, log its use
                      TSYMNM = TOKEN(1:TOKLEN)
                      TCLASS = 'X'
                      TDEFIN = .FALSE.
                      TLINEN = PRLINE
                      SYMNUM = SYMNUM + 1
                      CALL XTBUF
                      NEXT = .TRUE.
                    ELSE
C                     otherwise it was NOT previously defined and its
C                     use was therefore logged in the call to CKEXTR
                      NEXT = .TRUE.
                    END IF
                  END IF
                END IF
C
                IF (.NOT.NEXT .AND. .NOT.GETOUT) THEN
C                 token is not an EXTERNAL - get next token
                  NEXT = .TRUE.
                END IF
              END IF
            END IF
          END IF
        ELSE
C         no more tokens to process
          NXTFLG = .TRUE.
          GETOUT = .TRUE.
        END IF
C     token is not a character or delimeter, get next token, else return
      IF (.NOT.GETOUT) GOTO 100
      RETURN
      END
C
C
C
      SUBROUTINE   FNDSYM
     I                   (CSYMBL,
     M                    STARTL,
     O                    SYMLOC, ERRCOD)
C
C     + + + PURPOSE + + +
C     routine to scan main xref buffer to find previously captured
C     information about the symbol being processed
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER       STARTL, SYMLOC, ERRCOD
      CHARACTER*(*) CSYMBL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     CSYMBL - symbol to look for in the main xref buffer
C     STARTL - location in main buffer to begin search
C     SYMLOC - location in main buffer where information was found
C     ERRCOD - error code returned to calling program
C               0 - operation was successful
C              -1 - operation failed
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'cxref.inc'
      INCLUDE 'ctokeb.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER LOOP
      LOGICAL GETOUT
C
C     + + + END SPECIFICATIONS + + +
C
      ERRCOD = -1
      IF (SYMNUM .NE. 0) THEN
C       there are symbols to compare
C       if STARTL was not initialized in calling routine, do it here
        IF (STARTL .LE. 0) STARTL = 1
        SYMLOC =  0
        GETOUT = .FALSE.
        LOOP   = STARTL
 100    CONTINUE
          IF (LOOP .LE. SYMNUM) THEN
            IF (SYMNAM(LOOP) .EQ. CSYMBL) THEN
              SYMLOC = LOOP
              ERRCOD = 0
              GETOUT = .TRUE.
            ELSE
              LOOP = LOOP + 1
            END IF
          ELSE
            GETOUT = .TRUE.
          END IF
        IF (.NOT.GETOUT) GOTO 100
      END IF
      RETURN
      END
C
C
C
      SUBROUTINE   FNDEQU
     O                   (DONFLG, NXTFLG, ERRCOD)
C
C     + + + PURPOSE + + +
C     routine to find and capture usage information about
C     variables used in EQUIVALENCE statements
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER  ERRCOD
      LOGICAL  DONFLG, NXTFLG
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DONFLG - flag to tell calling routine that this routine
C              has located the end of the specification statements
C              in the source code file
C     NXTFLG - flag to tell calling routine that the token
C              buffer has been successfully processed and that
C              the next line can be fetched and processed.
C     ERRCOD - error code returned to calling program
C               0 - operation was successful
C              -1 - operation failed
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'cxref.inc'
      INCLUDE 'ctokeb.inc'
      INCLUDE 'ctokec.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER      SYMLOC, PLEVEL, LENONE, LENTWO, CAPTUR, ERRFLG
      CHARACTER*80 TEMPNM, TMPONE, TMPTWO
      LOGICAL      TORF, FIRST, GETOUT, NEXT
C
C     + + + INTRINSICS + + +
      INTRINSIC MOD
C
C     + + + EXTERNALS + + +
      EXTERNAL BUMPTK, ZIP, CLTBUF, XTBUF, GTCOMV, ERROUT, DUMPBF
C
C     + + + END SPECIFICATIONS + + +
C
      NXTFLG = .FALSE.
      DONFLG = .FALSE.
      GETOUT = .FALSE.
      PLEVEL = 0
      FIRST  = .TRUE.
      ERRCOD = 0
      LENONE = 0
      LENTWO = 0
      CALL CLTBUF
C     loop to increment token buffer counter and load temporary
C     token buffer
 100  CONTINUE
        CAPTUR = 0
        NEXT = .FALSE.
        TORF = .FALSE.
        CALL BUMPTK(1,ERRFLG)
        IF (ERRFLG .EQ. 0) THEN
C         process token
          IF (TTYPE .EQ. 'D') THEN
C           process delimeters
            IF (TOKEN(1:TOKLEN) .EQ. '(') THEN
C             token is an open parenthesis, increment paren counter
              PLEVEL = MOD(PLEVEL,2) + 1
            ELSE IF (TOKEN(1:TOKLEN) .EQ. ')') THEN
C             token is a close parenthesis, decrement paren counter
              PLEVEL = MOD(PLEVEL,2) - 1
            ELSE IF (TOKEN(1:TOKLEN) .NE. 1H,) THEN
C             unless token is a comma, an invalid delimeter was found
              CALL ERROUT ('Invalid delimeter','FNDEQU')
              CALL DUMPBF
            END IF
            NEXT = .TRUE.
          ELSE IF (TTYPE .EQ. 'C' .AND. PLEVEL .EQ. 1) THEN
C           token is a character string and inside one level of
C           parenthesis, process it
            CALL ZIP (' ',TEMPNM)
            TEMPNM = TOKEN(1:TOKLEN)
            IF (FIRST) THEN
C             this is the first variable of a pair
              CALL ZIP(' ',TMPONE)
              TMPONE = TEMPNM
              LENONE = TOKLEN
C             set FIRST = false since we already
C             have the first variable
              FIRST  = .FALSE.
              NEXT = .TRUE.
            ELSE
C             this is the second variable
              CALL ZIP(' ',TMPTWO)
              TMPTWO = TEMPNM
              LENTWO = TOKLEN
            END IF
            IF (.NOT.NEXT) THEN
C             we have two variables
C             see if first token is a COMMON variable
              CALL GTCOMV (TMPONE, TORF, SYMLOC, ERRCOD)
              IF (ERRCOD .NE. 0) THEN
                CALL ERROUT ('Error in call to GTCOMV','FNDEQU')
                GETOUT = .TRUE.
              ELSE IF (TORF) THEN
C               first variable is used in COMMON,
C               capture the second variable
C               and register it as a COMMON variable
                CAPTUR = 2
              ELSE
C               first variable was not a COMMON variable
C               check second variable
                CALL GTCOMV (TMPTWO, TORF, SYMLOC, ERRCOD)
                IF (ERRCOD .NE. 0) THEN
                  CALL ERROUT ('Error in call to GTCOMV','FNDEQU')
                  GETOUT = .TRUE.
                ELSE IF (TORF) THEN
C                 second variable is used in COMMON, capture the
C                 first variable name and register it as a COMMON
C                 variable
                  CAPTUR = 1
                END IF
              END IF
              IF (.NOT.TORF .AND. .NOT.GETOUT) THEN
C               neither variable is a COMMON variable,
C               loop for next pair
                NEXT = .TRUE.
              ELSE
C               token is a COMMON variable
C               capture equivalenced variable
                IF (CAPTUR .EQ. 1) THEN
                  TSYMNM = TMPONE(1:LENONE)
                ELSE IF (CAPTUR .EQ. 2) THEN
                  TSYMNM = TMPTWO(1:LENTWO)
                ELSE
                  NEXT = .TRUE.
                END IF
                IF (.NOT.NEXT) THEN
                  TCLASS = CLASS(SYMLOC)
                  TDEFIN = DEFIND(SYMLOC)
                  TATRB1 = ATRIB1(SYMLOC)
                  TATRB2 = ATRIB2(SYMLOC)
                  TATRB3 = ATRIB3(SYMLOC)
                  TCOMNM = COMNAM(SYMLOC)
                  TLINEN = PRLINE
                  TLNUSE = LINUSE(SYMLOC)
                  SYMNUM = SYMNUM + 1
                  CALL XTBUF
                  NEXT = .TRUE.
                END IF
              END IF
            END IF
          ELSE
C           token is not a character or delimeter - get next token
            NEXT = .TRUE.
          END IF
        ELSE
C         no more tokens to process
          NXTFLG = .TRUE.
          GETOUT = .TRUE.
        END IF
      IF (.NOT.GETOUT .AND. NEXT) GOTO 100
      RETURN
      END
C
C
C
      SUBROUTINE   FNDDEF
     I                   (CSYMBL,
     O                    DEFTYP, ERRCOD)
C
C     + + + PURPOSE + + +
C     routine to scan main IMPLICIT buffer to find default variable
C     type for variable being processed
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER       ERRCOD
      CHARACTER*(*) CSYMBL, DEFTYP
C
C     + + + ARGUMENT DEFINITIONS + + +
C     CSYMBL - symbol to find default type of
C     DEFTYP - default type as set in IMPLICIT statement
C     ERRCOD - error code returned to calling program
C               0 - operation was successful
C              -1 - operation failed
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'cimp.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER LOCA, LOCZ, LOCSYM, IPOS
C
C     + + + INTRINSICS + + +
      INTRINSIC ICHAR
C
C     + + + EXTERNALS + + +
      EXTERNAL ERROUT, DUMPBF
C
C     + + + END SPECIFICATIONS + + +
C
      ERRCOD = 0
C     determine character collation sequence position for first
C     character of variable passed from calling routine on this
C     computer
      LOCSYM = ICHAR(CSYMBL(1:1))
C     determine character collation sequence position for the letters
C     'A' and 'Z' on this computer
      LOCA   = ICHAR('A')
      LOCZ   = ICHAR('Z')
      IF (LOCZ .GT. LOCA) THEN
C       location of 'Z' is greater than 'A' (which is usually the case)
C       determine what position (1 - 26) LOCSYM is in the alphabet
        IPOS   = LOCSYM - (LOCA - 1)
C       get default variable type
        DEFTYP = ALPHAB(IPOS)
      ELSE IF (LOCA .GT. LOCZ) THEN
C       location of 'A' is greater than 'Z'
C       determine what position (1 - 26) LOCSYM is in the alphabet
        IPOS   = (LOCA + 1) - LOCSYM
        DEFTYP = ALPHAB(IPOS)
      ELSE
C       there is something wrong with this routine
        ERRCOD = -1
        CALL ERROUT (' Error LOCA = LOCZ','FNDDEF')
        CALL DUMPBF
      END IF
      RETURN
      END
C
C
C
      INTEGER FUNCTION   GPARVL
     I                          (CSYMBL)
C
C     + + + PURPOSE + + +
C     function to scan temporary PARAMETER table and extract the
C     value assigned to the PARAMETER
C
C     + + + DUMMY ARGUMENTS + + +
      CHARACTER*(*) CSYMBL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     CSYMBL - PARAMETER symbol to find assigned value of
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'ctokeb.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER LOOP
      LOGICAL GETOUT
C
C     + + + END SPECIFICATIONS + + +
C
      GPARVL = -1
      GETOUT = .FALSE.
      LOOP = 1
 100  CONTINUE
        IF (LOOP .LE. PARCNT) THEN
C         there are parameter values to examine
          IF (CSYMBL .EQ. PARMS(LOOP)) THEN
C           we have found the correct parameter value
            GPARVL = PARVAL(LOOP)
            GETOUT = .TRUE.
          END IF
        END IF
        LOOP = LOOP + 1
        IF (LOOP .GT. PARCNT) GETOUT = .TRUE.
      IF (.NOT.GETOUT) GOTO 100
      RETURN
      END
C
C
C
      SUBROUTINE   GCOMNM (
     O                     CNAME, ERRCOD)
C
C     + + + PURPOSE + + +
C     routine to get the name of COMMON
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER       ERRCOD
      CHARACTER*(*) CNAME
C
C     + + + ARGUMENT DEFINITIONS + + +
C     CNAME  - name of COMMON
C     ERRCOD - error code returned to calling program
C               0 - operation was successful
C              -1 - operation failed
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'ctokea.inc'
      INCLUDE 'ctokeb.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER COMSTR, COMEND, IPOS, ICNT, LOOP, IPOINT, OLDNUM, ERRFLG
      LOGICAL GETOUT, NEXT
C
C     + + + EXTERNALS + + +
      EXTERNAL LOADBF, ZIP, BUMPTK
C
C     + + + END SPECIFICATIONS + + +
C
      ERRCOD = 0
      OLDNUM = TNUM
      COMSTR = 0
      COMEND = 0
      CALL ZIP (' ',CNAME)
      GETOUT = .FALSE.
      NEXT = .TRUE.
C     loop until COMMON name is found
 100  CONTINUE
        CALL BUMPTK(1,ERRFLG)
        IF (ERRFLG .EQ. 0) THEN
C         process token
          IF (TOKEN .EQ. 1H/) THEN
C           register the location of the slashes
            IF (COMSTR .EQ. 0) THEN
C             location of starting element of COMMON name
              COMSTR = TNUM + 1
            ELSE
C             location of ending element of COMMON name
              COMEND = TNUM - 1
              NEXT = .FALSE.
            END IF
          END IF
        ELSE
C         token is out of range
          CNAME  = 'BLANK'
          GETOUT = .TRUE.
          NEXT   = .FALSE.
        END IF
      IF (.NOT.GETOUT .AND. NEXT) GOTO 100
      IF (.NOT.GETOUT) THEN
C       set pointer to first element of COMMON name
        IPOS = COMSTR
C       set counter to number of elements which make up the COMMON name
        ICNT = COMEND - COMSTR + 1
C       set pointer to CNAME character position to start filling
        IPOINT = 1
C       loop to concatonate the COMMON name out of the token pieces
        DO 200 LOOP = 1, ICNT, 1
C         build the COMMON name
          CNAME(IPOINT:(IPOINT+TKSIZE(IPOS))) = TKBUFF(IPOS)
C         increment character pointer
          IPOINT = IPOINT + TKSIZE(IPOS)
C         increment token buffer pointer
          IPOS = IPOS + 1
  200   CONTINUE
      END IF
      IF (CNAME .EQ. 'BLANK') THEN
        TNUM = OLDNUM
      ELSE
        TNUM = COMEND + 1
      END IF
      CALL LOADBF(ERRFLG)
      RETURN
      END
C
C
C
      SUBROUTINE   GVARI (
     O                     NXTFLG, ERRCOD)
C
C     + + + PURPOSE + + +
C     routine to capture variable names and as much information
C     as can be implied by the use of the name on the current
C     source code line
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER ERRCOD
      LOGICAL NXTFLG
C
C     + + + ARGUMENT DEFINITIONS + + +
C     NXTFLG - flag to tell calling routine that no additional
C              tokens in the token buffer need to be processed
C              .TRUE. if processing of current buffer is complete
C              .FALSE. otherwise
C     ERRCOD - error code returned to calling program
C               0 - operation was successful
C              -1 - operation failed
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'cxref.inc'
      INCLUDE 'ctokea.inc'
      INCLUDE 'ctokeb.inc'
      INCLUDE 'ctokec.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     CRINTE, SYMLOC, STARTL, VLENTH, ERRFLG, OLDTA2
      CHARACTER*1 DEFTYP, TTOKEN(32)
      LOGICAL     RWDFLG, GETOUT, NEXT, GOTTYP, LOGIT, MORDIM, T2SET
C
C     + + + FUNCTIONS + + +
      INTEGER GPARVL
C
C     + + + EXTERNALS + + +
      EXTERNAL CLTBUF, XTBUF,  CPTBUF, CRINTE, ERROUT, BUMPTK, ADVANC,
     +         FNDSYM, FNDDEF, GPARVL, DUMPBF, CVARAR, RWORD
C
C     + + + OUTPUT FORMATS + + +
 2000 FORMAT(/,' ILLEGAL VARIABLE NAME ENCOUNTERED -->',A32,/,
     +         ' Found on line ',I5,' of program module ',A12,/,
     +         ' This is an OSW coding convention reserved word',/,
     +         ' and may not be used as a variable name',/,
     +         ' If not corrected, this may cause erroneous errors',/,
     +         ' in the output generated by the MAKXRF module and',/,
     +         ' therefore errors in the SYSDOC output',/)
 2005 FORMAT(/,' ILLEGAL VARIABLE NAME ENCOUNTERED -->',A32,/,
     +         ' Found on line ',I5,' of program module ',A12,/,
     +         ' Variable name exceeds ANSI standard length ',
     +         ' of 6 characters',/)
C
C     + + + END SPECIFICATIONS + + +
C
      ERRCOD = 0
C     get next token
 100  CONTINUE
        TDIM1  = 0
        TDIM2  = 0
        TDIM3  = 0
        TDIM4  = 0
        GETOUT = .FALSE.
        NEXT   = .TRUE.
        T2SET  = .FALSE.
        LOGIT  = .FALSE.
        CALL BUMPTK(1,ERRFLG)
        IF (ERRFLG .EQ. 0) THEN
C         process token
          IF (TTYPE .EQ. 'C') THEN
C           token is a character string
            TSYMNM = TOKEN(1:TOKLEN)
            VLENTH = TOKLEN
C           call routine to see if a reserved word has been
C           used as a variable name
            CALL RWORD (TSYMNM, RWDFLG,  ERRCOD)
            IF (RWDFLG) THEN
C             a reserved word has been used as a variable name
C             write informative message but do not abort
              WRITE (*, 2000) TSYMNM, PRLINE, TMODUL
            END IF
C
            IF (TATRB1 .EQ. ' ') THEN
C             variable type not yet determined
C             initialize location pointer of variable in main buffer
              SYMLOC = 0
              GOTTYP = .FALSE.
C             loop until variable type information is found
 200          CONTINUE
                STARTL = SYMLOC + 1
C               call routine to scan main buffer for variable type info
                CALL FNDSYM (TSYMNM, STARTL, SYMLOC, ERRCOD)
                IF (ERRCOD .EQ. 0) THEN
C                 found some information about the variable type
                  IF (DEFIND(SYMLOC)) TATRB1 = ATRIB1(SYMLOC)
                  IF (TATRB1 .NE. ' ') GOTTYP = .TRUE.
                  TDEFIN = .FALSE.
                ELSE IF (TATRB1 .EQ. ' ') THEN
C                 no information found about variable type
C                 call routine to determine default variable type
                  CALL FNDDEF (TSYMNM, DEFTYP, ERRCOD)
                  IF (ERRCOD .NE. 0) THEN
                    ERRCOD = -1
                    CALL ERROUT (' Error in call to FNDDEF','GVARI')
                    CALL DUMPBF
                    GETOUT = .TRUE.
                  ELSE
                    TATRB1  = DEFTYP
                    GOTTYP = .TRUE.
                  END IF
                END IF
              IF (.NOT.GOTTYP .AND. .NOT.GETOUT) GOTO 200
            END IF
C
            IF (.NOT.GETOUT) THEN
              IF (TNUM .EQ. ITEMS) THEN
C               this is last token/variable
                LOGIT = .TRUE.
                NEXT  = .FALSE.
              ELSE
C               get next token
                CALL BUMPTK(1,ERRFLG)
                IF (TOKEN(1:TOKLEN) .EQ. ',') THEN
C                 token is a comma
C                 log information about prior variable
                  LOGIT = .TRUE.
                ELSE IF (TOKEN(1:TOKLEN) .EQ. '(') THEN
C                 token is a '(' therefore we have found an array
C                 loop to capture array dimensions
 30               CONTINUE
                    MORDIM = .FALSE.
                    CALL BUMPTK(1,ERRFLG)
                    CALL CVARAR (32, TOKEN, 32, TTOKEN)
C                   if array dimension is a number, capture it
C                   if variable is dimensioned with a parameter attempt to
C                   determine parameter value, otherwise, leave
C                   TDIMx = -1 which is the value returned by the call to
C                   CRINTE in the event a number is not present in TOKEN
                    IF (TTYPE .EQ. 'N' .OR. TTYPE .EQ. 'C') THEN
C                     token is numeric or parameter (character)
                      IF (TDIM1 .EQ. 0) THEN
C                       this is the first dimension
                        TDIM1 = CRINTE(-1,TOKLEN,TTOKEN)
C                       if CRINTE failed, assume token is a parameter
C                       and attempt to determine parameter value
                        IF (TDIM1 .EQ. -1) TDIM1 = GPARVL (TOKEN)
                      ELSE IF (TDIM2 .EQ. 0) THEN
C                       this is the second dimension
                        TDIM2 = CRINTE(-1,TOKLEN,TTOKEN)
C                       if CRINTE failed, assume token is a parameter
C                       and attempt to determine parameter value
                        IF (TDIM2 .EQ. -1) TDIM2 = GPARVL (TOKEN)
                      ELSE IF (TDIM3 .EQ. 0) THEN
C                       this is the third dimension
                        TDIM3 = CRINTE(-1,TOKLEN,TTOKEN)
C                       if CRINTE failed, assume token is a parameter
C                       and attempt to determine parameter value
                        IF (TDIM3 .EQ. -1) TDIM3 = GPARVL (TOKEN)
                      ELSE IF (TDIM4 .EQ. 0) THEN
C                       this is the fourth dimension
                        TDIM4 = CRINTE(-1,TOKLEN,TTOKEN)
C                       if CRINTE failed, assume token is a parameter
C                       and attempt to determine parameter value
                        IF (TDIM4 .EQ. -1) TDIM4 = GPARVL (TOKEN)
                      END IF
C                     this xref utility only supports up to 4 dimensional
C                     arrays - if this array exceeds this then loop to
C                     find end of dimension statement before proceeding
C                     to next variable
                      MORDIM = .TRUE.
C
                    ELSE IF (TDIM1 .NE. 0 .AND.
     +                       TOKEN(1:TOKLEN) .EQ. ',') THEN
C                     token is a comma, get next dimension
                      MORDIM = .TRUE.
                    ELSE IF (TDIM1 .NE. 0 .AND.
     +                       TOKEN(1:TOKLEN) .EQ. ')') THEN
C                     token is a right parin
                      MORDIM = .FALSE.
                      LOGIT = .TRUE.
                      IF (NTOKEN(1:1) .EQ. '*') THEN
                        OLDTA2 = TATRB2
                        T2SET  = .TRUE.
                        CALL BUMPTK(2,ERRCOD)
                        IF (TTYPE .EQ. 'N') THEN
C                         this is the length of the character variable
C                         convert it to integer
                          CALL CVARAR (32, TOKEN, 32, TTOKEN)
                          TATRB2 = CRINTE(-1,TOKLEN,TTOKEN)
                          IF (TATRB2 .EQ. -1) THEN
C                           failed to convert to integer
                            ERRCOD = -1
                            CALL ERROUT
     +                          (' Invalid specification statement',
     +                           'GVTYPE')
                            CALL DUMPBF
                            GETOUT = .TRUE.
                          END IF
                        END IF
                      END IF
                      IF (TNUM .LT. ITEMS) NEXT = .TRUE.
                    ELSE IF (TOKEN(1:TOKLEN) .EQ. '*') THEN
                      TDIM1  = -1
                      MORDIM = .TRUE.
                    ELSE IF (TDIM1 .EQ. 0) THEN
C                     left parin was followed by an invalid dimension
                      ERRCOD = -1
                      CALL ERROUT (' Invalid array dimension','GVARI')
                      CALL DUMPBF
                      GETOUT = .TRUE.
                    END IF
                  IF (MORDIM) GOTO 30
C
                  IF (.NOT.LOGIT .AND. .NOT.GETOUT) THEN
                    ERRCOD = -1
                    CALL ERROUT (' Invalid specification statement',
     +                  'GVARI')
                    CALL DUMPBF
                    GETOUT = .TRUE.
                  END IF
                ELSE IF (TOKEN(1:TOKLEN) .EQ. '*') THEN
                  CALL BUMPTK(1,ERRFLG)
                  IF (TTYPE .EQ. 'N') THEN
C                   found an integer dimension
                    CALL CVARAR (32, TOKEN, 32, TTOKEN)
                    TATRB2 = CRINTE(-1,TOKLEN,TTOKEN)
                    LOGIT = .TRUE.
                  ELSE IF (TOKEN(1:TOKLEN) .EQ. '(') THEN
C                   found a variable dimension
                    TATRB2 = -1
                    CALL ADVANC(')',ERRFLG)
                    IF (ERRFLG .EQ. 0) THEN
                      LOGIT = .TRUE.
                    ELSE
                      ERRCOD = -1
                      CALL ERROUT (' Invalid array dimension','GVARI')
                      CALL DUMPBF
                      GETOUT = .TRUE.
                    END IF
                  ELSE
                    ERRCOD = -1
                    CALL ERROUT (' Invalid array dimension','GVARI')
                    CALL DUMPBF
                    GETOUT = .TRUE.
                  END IF
                END IF
                IF (.NOT.LOGIT .AND. .NOT.GETOUT) THEN
                  ERRCOD = -1
                  CALL ERROUT (' Invalid specification statement',
     +                'GVARI')
                  CALL DUMPBF
                  GETOUT = .TRUE.
                END IF
              END IF
            END IF
          ELSE IF (TOKEN(1:TOKLEN) .EQ. ',') THEN
C           token is a comma, get next token
            NEXT = .TRUE.
          ELSE
C           invalid token
            ERRCOD = -1
            CALL ERROUT (' Invalid specification statement','GVARI')
            CALL DUMPBF
            GETOUT = .TRUE.
          END IF
C
          IF (.NOT.GETOUT .AND. LOGIT) THEN
C           found a variable - write it to main xref buffer
            IF (VLENTH .GT. 6) THEN
C             write error message if variable length is
C             greater than 6 characters (the ANSI standard)
              WRITE (*, 2005) TSYMNM, PRLINE, TMODUL
            END IF
            SYMNUM = SYMNUM + 1
            TLINEN = PRLINE
            CALL XTBUF
            IF (TNUM .GE. ITEMS) THEN
              CALL CLTBUF
              NXTFLG = .TRUE.
              GETOUT = .TRUE.
            ELSE IF (T2SET) THEN
              TATRB2 = OLDTA2
              T2SET  = .FALSE.
            END IF
          END IF
        ELSE
          NXTFLG = .TRUE.
          GETOUT = .TRUE.
          NEXT   = .FALSE.
        END IF
      IF (.NOT.GETOUT .AND. NEXT) CALL CPTBUF
      IF (.NOT.GETOUT .AND. NEXT) GOTO 100
      RETURN
      END
C
C
C
      SUBROUTINE   GVTYPE
     O                   (ERRCOD)
C
C     + + + PURPOSE + + +
C     routine to determine specification type
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER ERRCOD
C
C     + + + ARGUMENT DEFINITIONS + + +
C     ERRCOD - error code returned to calling program
C               0 - operation was successful
C              -1 - operation failed
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'ctokeb.inc'
      INCLUDE 'ctokec.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     CRINTE, ERRFLG
      CHARACTER*1 TTOKEN(32)
      LOGICAL     GETOUT
C    +            ,AGAIN
C
C     + + + FUNCTIONS + + +
      INTEGER GPARVL
C
C     + + + EXTERNALS + + +
      EXTERNAL CRINTE, ERROUT, DUMPBF, CVARAR, GPARVL, BUMPTK
C
C     + + + END SPECIFICATIONS + + +
C
      ERRCOD = 0
      GETOUT = .FALSE.
      CALL BUMPTK(1,ERRFLG)
      IF (TOKEN(1:TOKLEN) .EQ. '*') THEN
C       this is a variable type with a length attribute
C       (i.e. integer*2, integer*4, character*(*), etc)
        CALL BUMPTK(1,ERRFLG)
        IF (TATRB1 .EQ. 'C') THEN
C         character type variable
          IF (TOKEN(1:TOKLEN) .EQ. '(') THEN
C           process char*( statement
            CALL BUMPTK(1,ERRFLG)
            IF (TOKEN(1:TOKLEN) .EQ. '*') THEN
C             process char*(* statement
C             set attribute 2 to -1 to signal xref system that
C             these variables are dummy variables that assume
C             the length of the arguments passed to this routine
              TATRB2 = -1
              TCLASS = 'A'
              CALL BUMPTK(1,ERRFLG)
            ELSE IF (TTYPE .EQ. 'C') THEN
C             process char*(variable|parameter statement
C             set attribute 2 to -1 to signal xref system that
C             the length of these variables is determined by
C             the value of a variable or parameter
              TATRB2 = GPARVL(TOKEN)
              TCLASS = 'A'
              CALL BUMPTK(1,ERRFLG)
            ELSE IF (TTYPE .EQ. 'N') THEN
C             process char*(integer statement
C             this is the length of the character variable
C             convert it to integer
              CALL CVARAR (32, TOKEN, 32, TTOKEN)
              TATRB2 = CRINTE(-1,TOKLEN,TTOKEN)
              IF (TATRB2 .EQ. -1) THEN
C               failed to convert to integer
                ERRCOD = -1
                CALL ERROUT (' Invalid specification statement',
     +                       'GVTYPE')
                CALL DUMPBF
                GETOUT = .TRUE.
              END IF
            END IF
            IF (.NOT.GETOUT) THEN
              IF (TOKEN(1:TOKLEN) .NE. ')') THEN
C               something is wrong
                ERRCOD = -1
                CALL ERROUT (' Invalid specification statement',
     +                       'GVTYPE')
                CALL DUMPBF
                GETOUT = .TRUE.
              END IF
            END IF
          ELSE IF (TTYPE .EQ. 'N') THEN
C           process char*integer statements
C           this is the length of the character variable
C           convert it to integer
            CALL CVARAR (32, TOKEN, 32, TTOKEN)
            TATRB2 = CRINTE(-1,TOKLEN,TTOKEN)
            IF (TATRB2 .EQ. -1) THEN
C             failed to convert
              ERRCOD = -1
              CALL ERROUT (' Invalid specification statement',
     +            'GVTYPE')
              CALL DUMPBF
              GETOUT = .TRUE.
            END IF
          ELSE
C           character variable definition was followed
C           by illegal character
            ERRCOD = -1
            CALL ERROUT (' Invalid specification statement','GVTYPE')
            CALL DUMPBF
            GETOUT = .TRUE.
          END IF
        ELSE
C         process specification types other than character
          IF (TTYPE .EQ. 'N') THEN
C           this is the length of the character variable
C           convert it to integer
            CALL CVARAR (32, TOKEN, 32, TTOKEN)
            TATRB2 = CRINTE(-1,TOKLEN, TTOKEN)
            IF (TATRB2 .EQ. -1) THEN
C             failed to convert
              ERRCOD = -1
              GETOUT = .TRUE.
            END IF
          END IF
        END IF
      ELSE IF (TATRB1 .EQ. 'I') THEN
C       did not find an asterisk following 'INTEGER'
C       set attribute 2 to the default length supplied in parm.sd file
        TATRB2 = CINTLN
        TNUM = TNUM - 1
      ELSE
C       did not find an asterisk following specification type (other
C       than type = integer)
        IF (TATRB1 .EQ. 'C') THEN
C         set character to length 1 by default
          TATRB2 = 1
        END IF
C       reset TNUM to previous value prior to returning
        TNUM = TNUM - 1
      END IF
      RETURN
      END
C
C
C
      SUBROUTINE   FNDPAR
     O                   (NXTFLG, ERRCOD)
C
C     + + + PURPOSE + + +
C     routine to capture information about PARAMETERS used in
C     source code specification statements
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER ERRCOD
      LOGICAL NXTFLG
C
C     + + + ARGUMENT DEFINITIONS + + +
C     NXTFLG - flag to tell calling routine that no additional
C              tokens in the token buffer need to be processed
C              .TRUE. if processing of current buffer is complete
C              .FALSE. otherwise
C     ERRCOD - error code returned to calling program
C               0 - operation was successful
C              -1 - operation failed
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'cxref.inc'
      INCLUDE 'ctokeb.inc'
      INCLUDE 'ctokec.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     CRINTE, SYMLOC, STARTL, ERRFLG
      CHARACTER*1 TTOKEN(32)
      LOGICAL     GETOUT, MORSYM, MORPAR, LOGIT
C
C     + + + EXTERNALS + + +
      EXTERNAL CRINTE, ERROUT, FNDSYM, FNDDEF, XTBUF, CLTBUF,
     +         CPTBUF, DUMPBF, CVARAR, BUMPTK, ADVANC
C
C     + + + END SPECIFICATIONS + + +
C
      ERRCOD = 0
      GETOUT = .FALSE.
      TLINEN = PRLINE
      CALL BUMPTK(1,ERRFLG)
      IF (TOKEN(1:TOKLEN) .EQ. '(') THEN
C       found opening parenthesis
C       loop to capture each parameter
 100    CONTINUE
          MORPAR = .FALSE.
          LOGIT  = .FALSE.
C         process PARAMETER
          CALL BUMPTK(1,ERRFLG)
C         get parameter name and call FNDSYM to see if this PARAMETER
C         has been previously defined, if so, get variable type
          IF (TTYPE .EQ. 'C') THEN
C           found character string, this is variable or parameter
            TSYMNM = TOKEN(1:TOKLEN)
C           increment parameter counter
            PARCNT = PARCNT + 1
C
C           loop to read main xref buffer to find variable
C           type assigned to PARAMETER being processed
            SYMLOC = 0
            MORSYM = .TRUE.
 200        CONTINUE
              STARTL = SYMLOC + 1
              CALL FNDSYM (TSYMNM, STARTL, SYMLOC, ERRCOD)
              IF (ERRCOD .EQ. 0) THEN
                IF (ATRIB1(SYMLOC) .NE. ' ') TATRB1 = ATRIB1(SYMLOC)
                IF (ATRIB2(SYMLOC) .NE. 0)   TATRB2 = ATRIB2(SYMLOC)
              ELSE IF (ERRCOD .EQ. -1) THEN
                MORSYM = .FALSE.
                ERRCOD = 0
              END IF
            IF (MORSYM) GOTO 200
C
            IF (TATRB1 .EQ. ' ') THEN
C             variable type was not previously determined
C             use the default type or the type set in
C             an IMPLICIT statement
              CALL FNDDEF (TSYMNM, TATRB1, ERRCOD)
              IF (ERRCOD .NE. 0) THEN
                ERRCOD = -1
                CALL ERROUT (' Error in call to FNDDEF','FNDPAR')
                CALL DUMPBF
                GETOUT = .TRUE.
              END IF
            END IF
C
            IF (.NOT.GETOUT) THEN
C             capture the parameter name
              PARMS(PARCNT) = TSYMNM
              CALL BUMPTK(1,ERRFLG)
              IF (TOKEN(1:TOKLEN) .EQ. '=') THEN
C               capture the value assigned to the PARAMETER
                CALL BUMPTK(1,ERRFLG)
                IF (TTYPE .EQ. 'N' .AND. TATRB1 .EQ. 'I') THEN
C                 this appears to be an INTEGER PARAMETER
                  IF (NTOKEN .EQ. ',' .OR. NTOKEN .EQ. ')' ) THEN
C                   this appears to ba a PARAMETER that is
C                   assigned an integer value
                    CALL CVARAR (32, TOKEN, 32, TTOKEN)
                    PARVAL(PARCNT) = CRINTE(-1,TOKLEN, TTOKEN)
                    LOGIT = .TRUE.
                  ELSE
C                   this is a parameter with other than an integer value
C                   do not attempt to decipher it
                    PARVAL(PARCNT) = -1
C                   advance through token buffer until ')' is found
                    CALL ADVANC(')',ERRFLG)
                    IF (ERRFLG .EQ. 0) THEN
C                     found right parin ')', log parameter information
                      LOGIT = .TRUE.
                    ELSE
C                     failed to find right parin, error in source code
                      GETOUT = .TRUE.
                      ERRCOD = -1
                    END IF
                  END IF
                ELSE
C                 parameter set to value of an equation
                  PARVAL(PARCNT) = -1
C                 advance through token buffer until ')' is found
                  CALL ADVANC(')',ERRFLG)
                  IF (ERRFLG .EQ. 0) THEN
C                   found right parin ')', log parameter information
                    LOGIT = .TRUE.
                  ELSE
C                   failed to find right parin, error in source code
                    GETOUT = .TRUE.
                    ERRCOD = -1
                  END IF
                END IF
              ELSE
                ERRCOD = -1
                GETOUT = .TRUE.
              END IF
            END IF
          ELSE
            ERRCOD = -1
            GETOUT = .TRUE.
          END IF
C
          IF (.NOT.GETOUT .AND. LOGIT) THEN
C           found a parameter - write it to main xref buffer
            SYMNUM = SYMNUM + 1
            TLINEN = PRLINE
            CALL XTBUF
            CALL BUMPTK(1,ERRFLG)
            IF (ERRFLG .EQ. 0) THEN
              CALL CPTBUF
              IF (TOKEN(1:TOKLEN) .EQ. ')') THEN
C               found end of PARAMETER statement
                NXTFLG = .TRUE.
                ERRCOD = 0
                GETOUT = .TRUE.
              ELSE IF (TOKEN(1:TOKLEN) .EQ. ',') THEN
C               found comma separator
                MORPAR = .TRUE.
                GOTO 100
              ELSE
                ERRCOD = -1
                GETOUT = .TRUE.
              END IF
            ELSE
              CALL CLTBUF
              NXTFLG = .TRUE.
            END IF
          END IF
        IF (.NOT.GETOUT .AND. MORPAR) GOTO 100
      ELSE
C       the word 'PARAMETER' was not followed by a '('
        ERRCOD = -1
      END IF
C
      IF (ERRCOD .NE. 0) THEN
C       error occurred, print message
        CALL ERROUT (' Invalid PARAMETER statement','FNDPAR')
        CALL DUMPBF
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE   FNDCOM (
     O                      NXTFLG, ERRCOD)
C
C     + + + PURPOSE + + +
C     routine to capture information about COMMON variables
C     used in source code specification statements
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER ERRCOD
      LOGICAL NXTFLG
C
C     + + + ARGUMENT DEFINITIONS + + +
C     NXTFLG - flag to tell calling routine that no additional
C              tokens in the token buffer need to be processed
C              .TRUE. if processing of current buffer is complete
C              .FALSE. otherwise
C     ERRCOD - error code returned to calling program
C               0 - operation was successful
C              -1 - operation failed
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'ctokeb.inc'
      INCLUDE 'ctokec.inc'
C
C     + + + LOCAL VARIABLES + + +
      LOGICAL      GETOUT
      CHARACTER*32 NAMECM
C
C     + + + EXTERNALS + + +
      EXTERNAL ERROUT, DUMPBF, GVARI, GCOMNM, XTBUF, CPTBUF
C
C     + + + END SPECIFICATIONS + + +
C
      ERRCOD = 0
      GETOUT = .FALSE.
      TLINEN = PRLINE
      CALL GCOMNM (NAMECM, ERRCOD)
      IF (ERRCOD .EQ. 0) THEN
C       got name of COMMON
        TSYMNM = NAMECM
        TCLASS = 'B'
        TLNUSE = ' '
        SYMNUM = SYMNUM + 1
        CALL XTBUF
        CALL CPTBUF
      ELSE
        CALL ERROUT(' Error in call to GCOMNM','FNDCOM')
        CALL DUMPBF
        GETOUT = .TRUE.
      END IF
      IF (.NOT.GETOUT) THEN
C       set up temp xref buffer prior to fetching COMMON variables
        TCOMNM   = NAMECM
        TCLASS   = ' '
C       TLNUSE   = 'C'
        CALL GVARI (NXTFLG, ERRCOD)
        IF (ERRCOD .NE. 0 .OR. (.NOT.NXTFLG)) THEN
          CALL ERROUT(' Error in call to GVARI','FNDCOM')
          CALL DUMPBF
        END IF
      END IF
      RETURN
      END
