C
C
C
      SUBROUTINE   DUMPBF
C
C     + + + PURPOSE + + +
C     routine to dump contents of memory buffers in the event
C     of an error
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'ctokea.inc'
      INCLUDE 'ctokeb.inc'
      INCLUDE 'ctokec.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER       ISTART, IEND, LOOP
      CHARACTER*80  LINE, TEMPBF
C
C     + + + EXTERNALS + + +
      EXTERNAL ZIP
C
C     + + + OUTPUT FORMATS + + +
 2000 FORMAT(' Error on source code line ',I6,' in module ',A)
 2003 FORMAT(A)
 2005 FORMAT(' Error near item number ',I3,' ===> ',A)
 2010 FORMAT(' Blank line')
C
C     + + + END SPECIFICATIONS + + +
C
      WRITE(*,2000) PRLINE, TMODUL
      IF (ITEMS .GT. 0) THEN
        CALL ZIP(' ',LINE)
        CALL ZIP(' ',TEMPBF)
        ISTART = TKSTAR(1)
        IEND   = ISTART + TKSIZE(1)
        TEMPBF = TKBUFF(1)
        LINE(ISTART:IEND) = TEMPBF(1:TKSIZE(1))
        IF(ITEMS .GT. 1) THEN
C         more than 1 token exists
          DO 100 LOOP = 2,ITEMS
            IF (TKSTAR(LOOP) .LE. TKEND(LOOP-1)) THEN
C             there is a continuation line
C             dump current line, reinitialize, and contine
              WRITE(*,2003) LINE
              CALL ZIP(' ',LINE)
              CALL ZIP(' ',TEMPBF)
C             plug in character in column six for continuation
              LINE(6:6) = '+'
            END IF
            ISTART = TKSTAR(LOOP)
            IEND   = ISTART + TKSIZE(LOOP)
            TEMPBF = TKBUFF(LOOP)
            LINE(ISTART:IEND) = TEMPBF(1:TKSIZE(LOOP))
 100      CONTINUE
        END IF
        WRITE(*,2003) LINE
        WRITE(*,2005) TNUM, TOKEN
      ELSE
C       blank line
        WRITE(*,2010)
      END IF
      RETURN
      END
C
C
C
      SUBROUTINE   PRTENT
     O                   (ERRFLG)
C
C     + + + PURPOSE + + +
C     routine to print entry information to screen
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER ERRFLG
C
C     + + + ARGUMENT DEFINITIONS + + +
C     ERRFLG - error code returned to calling program
C               0 - operation was successful
C              -1 - operation failed
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'ctokea.inc'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER       ISTART, IEND, LOOP
      CHARACTER*80  LINE, TEMPBF
      LOGICAL       GOPRNT
C
C     + + + EXTERNALS + + +
      EXTERNAL ZIP
C
C     + + + OUTPUT FORMATS + + +
 2000 FORMAT(A)
C
C     + + + END SPECIFICATIONS + + +
C
      ERRFLG = 0
      CALL ZIP(' ',LINE)
      CALL ZIP(' ',TEMPBF)
      GOPRNT = .FALSE.
      ISTART = TKSTAR(1)
      IEND   = ISTART + TKSIZE(1)
      TEMPBF = TKBUFF(1)
      LINE(ISTART:IEND) = TEMPBF(1:TKSIZE(1))
      IF(ITEMS .GT. 1) THEN
C       more than 1 token exists
        LOOP = 1
 100    CONTINUE
          LOOP = LOOP + 1
          IF (LOOP .LE. ITEMS) THEN
            IF (TKBUFF(LOOP) .EQ. '(') THEN
              GOPRNT = .TRUE.
            ELSE IF (TKSTAR(LOOP) .LE. TKEND(LOOP-1)) THEN
C             there is a continuation line
              GOPRNT = .TRUE.
            ELSE
C             load next token
              ISTART = TKSTAR(LOOP)
              IEND   = ISTART + TKSIZE(LOOP)
              TEMPBF = TKBUFF(LOOP)
              LINE(ISTART:IEND) = TEMPBF(1:TKSIZE(LOOP))
            END IF
          ELSE
C           no more tokens
            GOPRNT = .TRUE.
          END IF
        IF (.NOT.GOPRNT) GOTO 100
        WRITE(*,2000) LINE
      ELSE
C       invalid entry point line
        ERRFLG = -1
      END IF
      RETURN
      END
