#!/bin/sh
# test.sh -- run sysdoc test data sets
#
# Usage: test.sh [start [stop]] [| tee test.out]
#
# History: 95/12/08  kmflynn

# pathname
WrdA=/usr/opt/wrdapp

#*******************************************************************
#***** You should not need to modify anything below this line. *****
#*******************************************************************

# pathnames and other variables
  Prgm=$WrdA/sysdoc1.0
  Data=$Prgm/data
  Chck=$Prgm/test

  exec 2>&1                                # stderr shows up in .out file
  Start=${1-1}                             # by default, start at 1
  Stop=${2-2}                              # by default, stop at 2
                                           # 1 -
                                           # 2 -


  FileTemp='call   cuse   nam  arg  doc  adef  farg  \
            scallu scuse  snam sarg sdoc sadef sfarg \
            scalld scuseq'
  FileOut='out int com unk ina ins'

# begin test runs
  echo
  echo _________________________________________________________________
  echo " Begin processing sysdoc test runs $Start to $Stop"
  echo " sysdoc program from: $Prgm"
  echo "      test data from: $Data"
  echo `date`

# remove any old temporary files
  for Fils in $FileTemp ; do
    if [ -f SD$Fils.t ] ; then rm SD$Fils.t ; fi
  done
# remove old versions of code and cross refernce file and get new ones
  for Fils in utilcc utilcn ; do
     if [ -f $Fils.f   ] ; then rm $Fils.f   ; fi
     if [ -f $Fils.XRF ] ; then rm $Fils.XRF ; fi
     ln -s $Data/$Fils.f $Fils.f
  done
  if [ -f const.inc ] ; then rm const.inc ; fi
  ln -s $Data/const.inc const.inc

  Test=$Start
  while [ $Test -ge $Start -a $Test -le $Stop -a $Test -le 2 ] ; do
#   each requested test run
    echo
    echo
    echo _________________________________________________________________
    echo "Test run number $Test"
    echo
#   remove old input and output files
    for Sfx in inp $FileOut ; do
      if [ -f test$Test.$Sfx ] ; then rm test$Test.$Sfx ; fi
    done
    if [ -f sysdoc.opt ] ; then rm sysdoc.opt ; fi
#   get option and input files
    ln -s $Data/test$Test.opt sysdoc.opt
    ln -s $Data/test$Test.inp test$Test.inp
 
#   run sysdoc
    $Prgm/bin/sysdoc

#   remove files no longer needed
    rm sysdoc.opt
    rm test$Test.inp

    Test=`expr $Test + 1`
  done

# remove source code files
  for Fils in const.inc utilcc.f utilcn.f ; do
    if [ -f $Fils ] ; then rm $Fils ; fi
  done

  echo
  echo
  echo _________________________________________________________________
  echo "Completed sysdoc test runs $Start to $Stop"
  echo
# check output against original output in data directory
  $Chck/check.sh $Data

# end of shell
